#include "brightness.h"
#include "common.h"
#include "resource.h"

int brightness_level;
int brightness_dimmed;
static int bright_time = 0;
int audiosd_flag = 1;
int cpu_oldfreq = 0;
static unsigned char tv_flag;

SDL_Surface* brightness_icon;
SDL_Rect brightness_icon_rect;

extern cfg_t *cfg_main;

int brightness_enabled()
{
    return cfg_getbool(cfg_main,"BrightDisp");
}

int brightness_is_dimmed() {
	return brightness_dimmed;
}

int get_bright_value()
{
	switch (brightness_level){
		case 20: return 0;
		case 40: return 1;
		case 60: return 2;
		case 80: return 3;
		case 99: return 4; 
	}
	return 0;
}
void brightness_init() 
{
    log_debug("Initializing");

#if 1
    brightness_icon = load_global_image("brightness.png");
    
    //Icon position
    init_rect(&brightness_icon_rect,
        BRIGHTNESS_ICON_X, BRIGHTNESS_ICON_Y,
        BRIGHTNESS_ICON_W, BRIGHTNESS_ICON_H);
#endif
    brightness_set((int)cfg_getint(cfg_main, "Bright"));
    bright_time = (int)cfg_getint(cfg_main,"DimmerDelay");
}
int get_bright_time()
{
	return bright_time;
}

void brightness_write(int level)
{
    #ifdef DINGOO_BUILD
	unsigned char buff[32] = {0};
        FILE *brt_fd = load_file_or_die(BACKLIGHT_DEVICE, "w");
	if (brt_fd == NULL){
		printf("open device: %s failed!\n",BACKLIGHT_DEVICE);
		return;
	}
	sprintf(buff,"%d",level);
	fwrite(buff,32,1,brt_fd);
	//fflush(brt_fd);
	//fsync(brt_fd);
	fclose(brt_fd);
    #endif

}
//alterac  add  
//gongfang
void stop_flush_screen()
{
		int level = 0;
	unsigned char buff[32] = {0};
        FILE *brt_fd = load_file(FLUSH_DEVICE, "w");
	if (brt_fd == NULL){
		printf("can't open deivce: %s\n",FLUSH_DEVICE);
		return;
	}
	sprintf(buff,"%d",level);
	fwrite(buff,32,1,brt_fd);
        //fprintf(brt_fd, "%d", level );
	//fflush(brt_fd);
	//		fsync(brt_fd);
        fclose(brt_fd);
}
void start_flush_screen()
{
		int level = 1;
	unsigned char buff[32] = {0};
        FILE *brt_fd = load_file(FLUSH_DEVICE, "w");
	if (brt_fd == NULL){
		printf("can't open deivce: %s\n",FLUSH_DEVICE);
		return;
	}
	sprintf(buff,"%d",level);
	fwrite(buff,32,1,brt_fd);
	//fflush(brt_fd);
	//		fsync(brt_fd);
        fclose(brt_fd);
}
void audio_write(int level)
{
    #ifdef DINGOO_BUILD
	unsigned char buff[32] = {0};
        FILE *brt_fd = load_file_or_die(AUDIO_DEVICE, "w");
	if (brt_fd == NULL){
		printf("open device: %s failed!\n",AUDIO_DEVICE);
		return;
	}
	sprintf(buff,"%d",level);
	fwrite(buff,32,1,brt_fd);
	//fflush(brt_fd);
	//		fsync(brt_fd);
        fclose(brt_fd);
    #endif
}
void set_a320_mode()
{
		int level = 1;
	unsigned char buff[32] = {0};
        FILE *brt_fd = load_file("/proc/jz/lcd_a320", "w");
	if (brt_fd == NULL){
		printf("can't open deivce: /proc/jz/lcd_a320\n");
		return;
	}
	sprintf(buff,"%d",level);
	fwrite(buff,32,1,brt_fd);
        fclose(brt_fd);

}
void clear_a320_mode()
{		int level = 0;
	unsigned char buff[32] = {0};
        FILE *brt_fd = load_file("/proc/jz/lcd_a320", "w");
	if (brt_fd == NULL){
		printf("can't open deivce: /proc/jz/lcd_a320\n");
		return;
	}
	sprintf(buff,"%d",level);
	fwrite(buff,32,1,brt_fd);
        fclose(brt_fd);

}
void audiosd_open()
{
		if (audiosd_flag == 0){
			printf("----------audosd is open!-----------\n");
			audio_write(1);
			audiosd_flag = 1;
		}
}
void audiosd_close()
{
		if (audiosd_flag == 1){
			printf("----------audosd is close!---------\n");
			audio_write(0);
			audiosd_flag = 0;
		}
}
//cpu device
int get_handle_value()
{
	return 0;
		int value;
		unsigned char buf[10];
		FILE* fp = load_file_or_die("/proc/jz/elan_pad","rb");
		if (fp != NULL){
				rewind(fp);
				fgets(buf, 9, fp);
				sscanf(buf, "%d", &value);
				fclose(fp);
				return value;
		}
		return -1;
}

void set_cpu_freq(int freq)
{
	return;
	if (freq <= 0)
		freq = MAX_CPU_FREQ;
	if (cpu_oldfreq != freq){
		cpu_oldfreq = freq;
		if (get_handle_value() == 0){
			if (freq > MAX_CPU_FREQ)
				freq = MAX_CPU_FREQ;
			if (freq < MIN_CPU_FREQ)
				freq = MIN_CPU_FREQ;
		}else{
				//freq = MAX_CPU_FREQ;
				return;
		}
		printf("-------set cur freq is--------- %d\n",freq);
		unsigned char buff[32] = {0};
		FILE *brt_fd = load_file(CPU_DEVICE, "w");
		if (brt_fd == NULL){
			printf("can't open device: %s\n",CPU_DEVICE);
			return;
		}
		sprintf(buff,"%d",freq*1000);
		fwrite(buff,32,1,brt_fd);
		//fflush(brt_fd);
		//fsync(brt_fd);
		fclose(brt_fd);
	}
}
void get_cpu_freq()
{
}
//udc

#define USB_DEVICE "/sys/devices/platform/musb_hdrc.0/uh_cable"
int get_udc_state()
{
	FILE* udc_fd = 0;
	char buf[128];

	udc_fd = fopen(USB_DEVICE,"r");
	if (udc_fd > 0){
		//udc device open success.
		rewind(udc_fd);
		fgets(buf,127,udc_fd);
		if (!strncasecmp(buf,"usb",3)){
			fclose(udc_fd);
			return USB;
		}else if (!strncasecmp(buf,"power",5)){
			fclose(udc_fd);
			return POWER;
		}else;
	}

	fclose(udc_fd);
	return NORMAL;
}

void udc_loop()
{
	printf("go to  udc  mode!\n");
	int ret = 1;
	//open udc
	system("/usr/bin/udc_connect.sh");
	sleep(1);
	while(ret){
		sleep(3);
		if (get_udc_state() != USB)
			ret = 0;
	}
	//close udc
	system("/usr/bin/udc_disconnect.sh");
	sleep(1);
	printf("go out udc mode!\n");
}

//change power

int get_change_state()
{
	int value;
	unsigned char buf[10];
	FILE* fp = load_file_or_die("/proc/jz/charge_device","rb");
	if (fp != NULL){
		rewind(fp);
		fgets(buf, 9, fp);
		sscanf(buf, "%d", &value);
		fclose(fp);
		printf("........change value......... = %d\n",value);
		return value;
	}
	return 0;
}

void set_change_state(int level)
{
	unsigned char buff[32] = {0};
	FILE *brt_fd = load_file_or_die("/proc/jz/charge_device", "w");
	if (brt_fd == NULL){
		printf("open device failed!\n");
		return;
	}
	sprintf(buff,"%d",level);
	fwrite(buff,32,1,brt_fd);
	//fflush(brt_fd);
	//fsync(brt_fd);
	fclose(brt_fd);
}

int get_tv_flag()
{
	return tv_flag;
}
void set_tv_flag(int n)
{
		tv_flag = n;
}

int get_tvdev_value()
{
		int value;
		unsigned char buf[10];
		FILE* fp = load_file("/proc/jz/tvout","rb");
		if (fp != NULL){
				rewind(fp);
				fgets(buf, 9, fp);
				sscanf(buf, "%d", &value);
				fclose(fp);
				return value;
		}
		return 0;
}
//end

void brightness_change(Direction dir)
{
    brightness_set(brightness_level + (dir==PREV?-1:1)*10);
}

void brightness_dim(int on) 
{
    if (brightness_dimmed != on)
    {
        printf("Setting Dim to %d", on);
        brightness_dimmed = on;
		if (tv_flag == 0)
        	brightness_write(on?0:brightness_level);
		else
        	brightness_write(0);
    }
}

void brightness_dim_tvopen() 
{
		tv_flag = 1;
    	brightness_write(0);
}

void brightness_dim_tvclose(void) 
{
		tv_flag = 0;
    	brightness_write(brightness_level);
}
void brightness_close() 
{
    	brightness_write(0);
}

void brightness_open(void) 
{
		if (tv_flag == 0)
    		brightness_write(brightness_level);
		else
    		brightness_write(0);
}

void brightness_set_new()
{
    	brightness_write(brightness_level);
}

void brightness_set(int level) 
{
    brightness_dimmed = 0;
    brightness_level = bound(level, 9, 99);
	if (tv_flag == 0)
    	brightness_write(brightness_level);
	else
    	brightness_write(0);
    cfg_setint( cfg_main, "Bright", (long)brightness_level );
}

void brightness_set_nowritecfg(int level) 
{
    brightness_dimmed = 0;
    brightness_level = bound(level, 9, 99);
	if (tv_flag == 0)
    	brightness_write(brightness_level);
	else
    	brightness_write(0);
    //cfg_setint( cfg_main, "Bright", (long)brightness_level );
}


void brightness_show(SDL_Surface *surface) 
{
    int alpha = (int)(255.0*(brightness_level/100.0));
    blitSurfaceAlpha(brightness_icon, NULL, surface, &brightness_icon_rect, alpha);
}
void gsensor_show(SDL_Surface *surface) 
{
    blitSurfaceAlpha(brightness_icon, NULL, surface, &brightness_icon_rect, 255);
}

void brightness_deinit() 
{
    log_debug("De-initializing");
    free_surface(brightness_icon);

}
void open_sdl_key_even()
{
	int level = 1;
	unsigned char buff[32] = {0};
	FILE *brt_fd = load_file("/proc/jz/alt", "w");
	if (brt_fd == NULL){
		printf("can't open deivce: /proc/jz/alt \n");
		return;
	}
	sprintf(buff,"%d",level);
	fwrite(buff,32,1,brt_fd);
	//fflush(brt_fd);
	//fsync(brt_fd);
	fclose(brt_fd);
}
