#include <stdio.h>
#include <unistd.h>
#include "env.h"

#define DMENU_CRC_FILE "/usr/etc/dmenu/crc_tmp.ini"
#define DMENU_LOCK_CRC_FILE "/usr/etc/dmenu/lock_crc_tmp.ini"

/**** Add crc for file *******/
 int check_crc_file(const char *filename)
{
	FILE *file;
	int ret;
	file = fopen(filename, "r");
	if (file == NULL)
	{
		return -1;
	}
	fclose(file);
	
	//check crc	
	ret = check_file_crc_new(filename,DMENU_CRC_FILE);
	if(ret)
	{
		printf("CRC OK!\n");
		return 0;
	}
	else
	{
		printf("CRC ERROR!\n");
		remove(filename);
		return -1;
	}
}

 int check_lock_crc_file(const char *filename)
{
	FILE *file;
	int ret;
	file = fopen(filename, "r");
	if (file == NULL)
	{
		return -1;
	}
	fclose(file);
	
	//check crc	
	ret = check_file_crc_new(filename,DMENU_LOCK_CRC_FILE);
	if(ret)
	{
		printf("CRC OK!\n");
		return 0;
	}
	else
	{
		printf("CRC ERROR!\n");
		remove(filename);
		return -1;
	}
}

 void add_lock_crc_file(const char *filename)
{
	FILE* file=NULL;
	FILE* fp=NULL;
	char *file_buff=NULL;
	int file_size;
	file = fopen(filename, "r+");
	if (file == NULL){
		return;
	}
	fseek(file,0,SEEK_END);
	file_size = ftell(file);
	file_buff = (char*)malloc(sizeof(char)*file_size);
	memset(file_buff,'\0',file_size);
	fseek(file,0,SEEK_SET);
	fread(file_buff,1,file_size,file);
	
	//cal crc
        int start_crc = 0;
        start_crc = calc_crc32(start_crc, (unsigned char *)(file_buff),file_size);
        //write crc
	fp = fopen(DMENU_LOCK_CRC_FILE,"w");
	if (fp == NULL){
		printf("can't open dmenu crc file!\n");
		fclose(file);
		if(file_buff) free(file_buff);
		return;
	}
	fwrite(&start_crc, sizeof(int), 1, fp);
        fflush(fp);
        fsync(fileno(fp));
	fclose(fp);
	fclose(file);
	if(file_buff) free(file_buff);
}

 void add_crc_file(const char *filename)
{
	FILE* file=NULL;
	FILE* fp=NULL;
	char *file_buff=NULL;
	int file_size;
	file = fopen(filename, "r+");
	if (file == NULL){
		return;
	}
	fseek(file,0,SEEK_END);
	file_size = ftell(file);
	file_buff = (char*)malloc(sizeof(char)*file_size);
	memset(file_buff,'\0',file_size);
	fseek(file,0,SEEK_SET);
	fread(file_buff,1,file_size,file);
	
	//cal crc
        int start_crc = 0;
        start_crc = calc_crc32(start_crc, (unsigned char *)(file_buff),file_size);
        //write crc
	fp = fopen(DMENU_CRC_FILE,"w");
	if (fp == NULL){
		printf("can't open dmenu crc file!\n");
		fclose(file);
		if(file_buff) free(file_buff);
		return;
	}
	fwrite(&start_crc, sizeof(int), 1, fp);
        fflush(fp);
        fsync(fileno(fp));
	fclose(fp);
	fclose(file);
	if(file_buff) free(file_buff);
}

/***************************************************/


