/*
 *  Copyright (C) 2009 sca <scahoo <at> gmail <dot> com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
 
#ifndef __DOSD_H__
#define __DOSD_H__

#include <SDL.h>
#include <stdint.h>
#include <stdbool.h>

int dosd_init();
void dosd_deinit();
void dosd_show(SDL_Surface *surface);
void dosd_color_reset();
bool get_usb_connect_state();

inline bool dosd_is_locked();
bool dosd_is_charging();

//alterac  add
#if 0
typedef enum {
    BAT_LEVEL_BEST=3900,
    BAT_LEVEL_FAIR=3700,
    BAT_LEVEL_LOW=3611
} BatteryLevel;
#else
typedef enum {
    BAT_LEVEL_BEST=4150,
    BAT_LEVEL_FAIR=3900,
    BAT_LEVEL_FAIR1=3800,
    BAT_LEVEL_LOW=3700
} BatteryLevel;
#endif
typedef enum {
    BAT_STATE_EMPTY = 0,
    BAT_STATE_LEVEL1,
    BAT_STATE_LEVEL2,
    BAT_STATE_LEVEL3,
    BAT_STATE_LEVEL4,
    BAT_STATE_FULL,
	BAT_STATE_CHARGING,
    BAT_STATE_MAX
} BatteryState;

#define BATTERY_X (SCREEN_WIDTH - 40)
#define BATTERY_Y 5
#define BATTERY_W 32
#define BATTERY_H 22


#define BATTERY_CHANGE_X 0
#define BATTERY_CHANGE_Y 0
#define BATTERY_CHANGE_W 160 
#define BATTERY_CHANGE_H 240

#define RES_BAT_CHANGE "/usr/local/dmenu/resources/charge_b.png"
#define RES_BAT_NULL "/usr/local/dmenu/resources/batzero_b.png"
#define RES_BAT_FULL "/usr/local/dmenu/resources/batfull_b.png"

#define RES_BIG_BAT_FULL "/usr/local/dmenu/resources/big_full.png"
#define RES_BIG_BAT_NULL "/usr/local/dmenu/resources/big_null.png"

#endif//__DOSD_H__
