/*
 *  Copyright (C) 2009 Rookie1 <mr.rookie1@gmail.com>
 *
 *  Author: <mr.rookie1@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include <stdlib.h>
#include <unistd.h>
#include <dirent.h>
#include <limits.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <linux/fs.h>
#include <fcntl.h>
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_ttf.h>
#include "env.h"
#include "conf.h"
#include "filelist.h"
#include "resource.h"
#include "menu.h"

#include "sound.h"
#include "dingoo.h"
#include "res_utf8.h"

#define ends_with_slash(str) (str[strlen(str)-1] == '/')
#define TMP_DIR "/tmp/filelist.ini"

//Get access to the current menu item
extern cfg_t* menu_active_item_config;
extern cfg_t *cfg;
extern SDL_Surface* background;

SDL_Surface* list_bg;
SDL_Surface* list_sel;
SDL_Surface* list_title;

SDL_Surface* list_dir_icon;
SDL_Surface* list_file_icon;

TTF_Font* list_font;
SDL_Color* list_font_color;
extern char old_state;

int old_list_start,old_highlight;
#if ELAN_CONNECT
int server_flag = 0,client_flag = 0,single_flag = 0;
#elif P2P_CONNECT
int server_flag = -1,client_flag = -1,single_flag = 0;
#endif
int isDrawFlag = 0;

 extern char handle_value;
extern int isOpenScreen;
typedef struct FileListGlobal 
{
    int status_changed;
    
    struct dirent **namelist;
    struct stat *statlist;
    SDL_Surface* list_filename[FILES_PER_PAGE]; 
    int num_of_files; // total number of files under current directory
    int current_list_start; // index of the file at top of current page
    int current_highlight; // index of the file being highlighted
    int at_root; //Whether or not the listing is at the root of the file system
    int can_change_dir;
    int is_initted;
    
    char current_path[PATH_MAX];
    char work_path[PATH_MAX];
    char current_executable[PATH_MAX];
    
} FileListGlobal;
typedef struct FileListGlobal_new
{
	int total_num;
    int cur_index;
    char** filename;
} FileListGlobal_new;

FileListGlobal fl_global;
char filelist_path[PATH_MAX];
extern char file_format[FORMAT_MAX];
extern SDL_Surface* exp_bk_face;
extern SDL_Surface* exp_item_face;


#if 0
extern const char* res_single[MAX_LAN];
extern const char* res_create[MAX_LAN];
extern const char* res_search[MAX_LAN];

extern const char* res_open[MAX_LAN];
extern const char* res_delete[MAX_LAN];
#endif
void init_flglobal()
{
    fl_global.current_list_start = fl_global.current_highlight = 0;
}
void reinit_flglobal(int start,int high)
{
		fl_global.current_list_start = start;
		fl_global.current_highlight = high;
}

SDL_Surface* filelist_render_text(char* text) 
{
    return draw_text(text, list_font, list_font_color);
}

void filelist_fill()
{
    int i, j;
		int lang_value = get_sys_language();
    //Clear old entries
    for (i=0;i<FILES_PER_PAGE;i++) 
    {
        if (fl_global.list_filename[i]) 
        {
            SDL_FreeSurface(fl_global.list_filename[i]);
            fl_global.list_filename[i] = NULL;
        }
    }
    
    //Write new entries
    for (i=0,j=fl_global.current_list_start; i<FILES_PER_PAGE; i++,j++) 
    {
        if (j < fl_global.num_of_files) 
	{
		//alterac  add
		if (j == 0 && !fl_global.at_root){
			fl_global.list_filename[i] = 
				filelist_render_text(cfg_getstr(cfg,"Leftdir"));
		}else{
			if (fl_global.at_root){

				if (i == 0){
					fl_global.list_filename[i] = 
						filelist_render_text(res_udisk[lang_value]);
				}else if (i == 1){
					fl_global.list_filename[i] = 
						filelist_render_text(res_mmc[lang_value]);
				}else{
					fl_global.list_filename[i] = 
						filelist_render_text(fl_global.namelist[j]->d_name);
				}
			}else{
				fl_global.list_filename[i] = 
					filelist_render_text(fl_global.namelist[j]->d_name);
			}
		}
	}
    }
}

void write_file_list()
{
		FILE*fp;
		int cur_index = fl_global.current_highlight + fl_global.current_list_start - 1;
		if (cur_index < 0)
				cur_index = 0;
		fp = fopen(TMP_DIR,"wb");
		fwrite(&cur_index,1,sizeof(int),fp);
		fclose(fp);
}
void remove_file_list()
{
		FILE*fp;
		char tmp_str[64];
		memset(tmp_str,0,64);
		fp = fopen(TMP_DIR,"rb");
		if (fp != NULL){
				fclose(fp);
				sprintf(tmp_str,"rm  %s",TMP_DIR);
				system(tmp_str);
		}
}

void max_to_min(char * str)
{
		int size,i;
		if (str == NULL)
				return;
		size = strlen(str);
		for (i=0;i<size;i++){
				if (str[i]>='A'&&str[i]<='Z'){
						str[i] = str[i] + 32;
				}
		}
}

//alterac add
#if 0
int filelist_filter(const struct dirent *dptr)
{
    return (fl_global.can_change_dir && !fl_global.at_root && is_back_dir(dptr)) 
            || dptr->d_name[0] != '.';
}
#else
int filelist_filter(const struct dirent *dptr)
{
		char * tmp_char;
		char str_format[64];
		struct stat* stat_file; 
		stat_file = new_array(struct stat,1);
		char *filename = new_str(strlen(filelist_path) + strlen(dptr->d_name) + 2);
		strcpy(filename, filelist_path);
		strcat(filename, "/");
		strcat(filename, dptr->d_name);
		stat(filename, stat_file);
		memset(str_format,0,64);
		//dir is no need leach,file is need
		if (S_ISDIR(stat_file->st_mode)){
				if(strcasecmp(dptr->d_name,"emulator") == 0 )
					return 0;
				if ((fl_global.can_change_dir && !fl_global.at_root && is_back_dir(dptr)) 
								|| dptr->d_name[0] != '.'){
						free_erase(filename);
						free_erase(stat_file);
						return 1;
				}
				else{
						free_erase(filename);
						free_erase(stat_file);
						return 0;
				}
		}else{

				if ((fl_global.can_change_dir && !fl_global.at_root && is_back_dir(dptr)) 
								|| dptr->d_name[0] != '.'){
						if ((tmp_char = strrchr(dptr->d_name,'.')) == NULL){
								free_erase(filename);
								free_erase(stat_file);
								return 0;
						}else{
										// have "!" is no  need  leach file suffix
										if (file_format[0] == '!'){      
												free_erase(filename);
												free_erase(stat_file);
												return 1;
										}else{
												//change max char to min char
												max_to_min(file_format);
												memcpy(str_format,tmp_char,strlen(tmp_char)+1);
												max_to_min(str_format);
												//start compare string
												if (strstr(file_format,str_format) != NULL){
														free_erase(filename);
														free_erase(stat_file);
														return 1;
												}else{
														free_erase(filename);
														free_erase(stat_file);
														return 0;
												}
										}
								}
				}else{
								free_erase(filename);
								free_erase(stat_file);
								return 0;
				}
		}
}
#endif
//end

int filelist_sort(const struct dirent **a, const struct dirent **b) 
{
    //Note this fails for symlinks of dirs, but because the dingux runs on a Fat32 drive, this
    // shouldn't be an issue.
    if ((*a)->d_name[0] == '.' || (*b)->d_name[0] == '.') 
    {
        return is_back_dir(*a) ? -1 : 1;
    }

    int c = (*a)->d_type==DT_DIR, d=(*b)->d_type==DT_DIR;
    return c==d ? alphasort_i(a,b) : c ? -1 : 1;
}
extern int unlock_to_game;
int filelist_get_list(char* path)
{
	int i = 0, *p = NULL, j, count =  0, flag = 0;
	char *c = NULL;
	struct dirent **q;
	//alterac  add
	memset(filelist_path,0,PATH_MAX);
	strcpy(filelist_path,path);
	//end
	fl_global.at_root = !strcmp(path,"/mnt");   //root dir
	fl_global.num_of_files = scandir(path, &fl_global.namelist, filelist_filter, (void*)filelist_sort);
	printf("%s %d unlock_to_game = %d\n", __func__, __LINE__, unlock_to_game);
	if (unlock_to_game == 0)
	{
		p = malloc(sizeof(int) * fl_global.num_of_files);
		for (j = 0; j < fl_global.num_of_files; j++)
			p[j] = 0;
		for (i = 0; i < fl_global.num_of_files; i++)
		{
			if ((c = strrchr(fl_global.namelist[i]->d_name, '.')) != NULL)
			{
				if ((strstr(".zip .bin .cbn .zip .fba .gba .sfc .smc .smd .nes .gbc .sms .gg .gb", c) != NULL) && (strstr(".", c) == NULL) && (strstr("..", c) == NULL))
				{
					p[i] = 1;
					count++;
				}		
			}
		}
		if (count != 0)
		{
			j = 0;
			q = (struct dirent **)malloc(sizeof(struct dirent *) * (fl_global.num_of_files - count));
			for (i = 0; i < fl_global.num_of_files; i++)
			{
				if (flag < fl_global.num_of_files)
				{
					if (p[flag] == 1)
					{
						free(fl_global.namelist[flag]);
						for (flag += 1; flag < fl_global.num_of_files; flag++)
						{
							printf("%s %d j = %dflag =  %d p[%d] = %d\n", __func__, __LINE__, j, flag, flag, p[flag]);
							if (p[flag] == 0)
								break;
						}
						if (flag < fl_global.num_of_files)
						{
							q[j] = fl_global.namelist[flag];
							j++;
							flag++;
							printf("%s %d j = %dflag =  %d p[%d] = %d\n", __func__, __LINE__, j, flag, flag, p[flag]);
						}
					}
					else
					{
						q[j] = fl_global.namelist[flag];
						flag++;
						j++;
					}		
				}

			}
		free(fl_global.namelist);
		fl_global.namelist = q;
		q = NULL;
		fl_global.num_of_files -= count;
	}
		free(p);
	}
	//alterac del
	//fl_global.current_list_start = fl_global.current_highlight = 0;
	printf("num_of_files = %d  current_list_start = %d\n",fl_global.num_of_files,fl_global.current_list_start);

	if (fl_global.num_of_files < 0) 
	{
		fl_global.num_of_files = 0;
		return -1;
	}
	else {
		fl_global.statlist = new_array(struct stat, fl_global.num_of_files);
		for (i=0;i<fl_global.num_of_files;i++) 
		{
			char *filename = new_str(strlen(path) + strlen(fl_global.namelist[i]->d_name) + 2);
			strcpy(filename, path);
			strcat(filename, "/");
			strcat(filename, fl_global.namelist[i]->d_name);
			stat(filename, &fl_global.statlist[i]);
			free_erase(filename);
		}
		strcpy(fl_global.current_path, path);
		filelist_fill();
		return 0;
	}
}

void filelist_clear_list()
{
    free_erase(fl_global.statlist);
    
    if (fl_global.namelist) 
    {
        int i, j;
        for (i=0;i<fl_global.num_of_files;i++) free_erase(fl_global.namelist[i]);
        
        free_erase(fl_global.namelist);
    
        for (i=0, j=fl_global.current_list_start;
            (i < FILES_PER_PAGE) && (j < fl_global.num_of_files);
            i++, j++) 
        {
            free_surface(fl_global.list_filename[i]);
        }
    }
    
    fl_global.current_list_start = fl_global.current_highlight = fl_global.num_of_files = 0;
}



int filelist_init(char* title, char* executable, char *exec_path, char* select_path, int can_change_dirs)
{
    log_debug("Initializing");
    
    //Make sure it is something
    if (executable == 0) executable = "";
    
    // load font
    list_font       = get_theme_font(FILE_LIST_FONT_SIZE);   //18
    //TTF_SetFontStyle(list_font,TTF_STYLE_BOLD);
    list_font_color = get_theme_font_color();

    //Setup UI
    list_bg        = load_theme_image(cfg_getstr(cfg, "ListBackground"));
    list_sel       = load_theme_image(cfg_getstr(cfg, "ListSelector"));
    list_dir_icon  = load_theme_image(cfg_getstr(cfg, "ListDirIcon"));
    list_file_icon = load_theme_image(cfg_getstr(cfg, "ListFileIcon"));
    list_title     = filelist_render_text(title);    //draw title 
    fl_global.status_changed = 1;

    // Prep path/executable vars, determine filelist_theme status
    strcpy(fl_global.current_executable, executable);
    strcpy(fl_global.work_path, exec_path);

    fl_global.can_change_dir = can_change_dirs;
    
    // read files
    char real_path[PATH_MAX];
    if (!realpath(select_path, real_path)) 
    {
        printf("Failed to get real path of directory %s", select_path);
        //strcpy(real_path, "/mnt/mmc"); //Default to root when real_path fails
//alterac add
		char str[PATH_MAX];
		memset(str,0,PATH_MAX);
		sprintf(str,"mkdir -p %s",select_path);
		system(str);
		strcpy(real_path,select_path);
//end
    }
    if (filelist_get_list(real_path)) 
    {
        printf("Failed to read directory %s", real_path);
        return 1;
    }

    fl_global.is_initted = 1;
    
    return 0;
}

void filelist_deinit()
{
    if (!fl_global.is_initted) return;
    log_debug("De-initializing");
    
    fl_global.is_initted = 0;

    free_surface(list_bg);
    free_surface(list_sel);
    free_surface(list_title);
    free_surface(list_dir_icon);
    free_surface(list_file_icon);
    free_font(list_font);
    free_color(list_font_color);

    filelist_clear_list();
}

int filelist_draw(SDL_Surface* screen)
{
    int i;
    SDL_Rect image_rect, text_rect;

    if (!fl_global.status_changed) return 0;
    init_rect_pos(&image_rect, 0,0);
    init_rect_pos(&text_rect, 0,0);

    // clear screen
	SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,0));  //alterac add
    SDL_BlitSurface(background, 0, screen, &image_rect);
    SDL_BlitSurface(list_bg,    0, screen, &image_rect);

    text_rect.y = FILE_LIST_OFFSET;
    for (i=0; i<FILES_PER_PAGE; i++) 
    {
        if (fl_global.list_filename[i]) 
        {
            if (i == fl_global.current_highlight) 
            {
                SDL_BlitSurface(list_sel, 0, screen, &text_rect);
            }
            
            if (S_ISDIR(fl_global.statlist[fl_global.current_list_start+i].st_mode)) 
            {
                SDL_BlitSurface(list_dir_icon, 0, screen, &text_rect);
                text_rect.x += list_dir_icon->w;
            }
            else {
                SDL_BlitSurface(list_file_icon, 0, screen, &text_rect);
                text_rect.x += list_file_icon->w;
            }
			SDL_BlitSurface(fl_global.list_filename[i], 0, screen, &text_rect);
            text_rect.x = 0;
            text_rect.y += FILE_ENTRY_HEIGHT;
        }
    }

    fl_global.status_changed = 0;
    return 1;
}

void filelist_animate(SDL_Surface* screen) {}
void filelist_osd(SDL_Surface* screen) 
{
    SDL_Rect rect;
    init_rect_pos(&rect, 0,0);
    SDL_BlitSurface(list_title, 0, screen, &rect);
    dosd_show(screen);    
    //if (volume_enabled())     volume_show(screen);
}

void filelist_shift_page(Direction dir) 
{
    int i, 
        start = 0, 
        end = FILES_PER_PAGE-1, 
        delta = 1;

    if (dir == PREV) 
    {
        start = FILES_PER_PAGE-1;
        end = 0;
        delta = -1;
    }
        
    SDL_FreeSurface(fl_global.list_filename[start]);
    for (i=start;i!=end;i+=delta) 
    {
        fl_global.list_filename[i] = fl_global.list_filename[i+delta];
    }
    
	fl_global.current_list_start += delta;
	//alterac add for fornt dir
	if ((fl_global.current_list_start+end) == 0){
			fl_global.list_filename[end] = filelist_render_text(cfg_getstr(cfg,"Leftdir"));
	}else{
			fl_global.list_filename[end] = filelist_render_text(fl_global.namelist[fl_global.current_list_start+end]->d_name);
	}
}

void filelist_wrap_page(Direction dir) 
{
    int size = FILES_PER_PAGE;

    if (dir != PREV) 
    { //start at top
        fl_global.current_list_start = 0; 
        fl_global.current_highlight  = 0;
    } 
    else {
        fl_global.current_list_start = max(fl_global.num_of_files - size, 0);
        fl_global.current_highlight  = min(fl_global.num_of_files - 1, size - 1); 
    }
    filelist_fill();
}

void filelist_move_entry(Direction dir) 
{
    int delta    = (dir == PREV) ? -1 : 1;
    int size     = FILES_PER_PAGE;
    int max      = fl_global.num_of_files;
    int next_pos = fl_global.current_highlight + delta;
    int next_abs_pos = fl_global.current_list_start + next_pos; 
    
    sound_out( MENUITEM_MOVE );
    if (in_bounds(next_pos,0,size) && next_pos < max) //If moving within page
    {
        fl_global.current_highlight += (PREV==dir ? -1 : 1);
    } 
    else if (in_bounds(next_abs_pos, 0, max)) //Slide page
    {
        filelist_shift_page(dir);
    }
    else  //Wrap Around
    {
        filelist_wrap_page(dir);
    }    
    
    fl_global.status_changed = 1;
}


void filelist_move_page(Direction dir)
{
    int size = FILES_PER_PAGE, delta = (dir==PREV?-size:size);;
    int start = fl_global.current_list_start;
    int next = start + delta;
    sound_out( MENU_MOVE );
    fl_global.current_list_start =  bound(next, 0, max(fl_global.num_of_files-size, 0));
    fl_global.current_highlight = 0;
    
    filelist_fill();
    
    fl_global.status_changed = 1;
}

void filelist_move_left()
{
    sound_out( CANCEL );

    if (fl_global.at_root) 
    {
        return;
    } 
    else {
        char* last_separator = strrchr(fl_global.current_path, '/');
        if (!last_separator)
        {
            log_error("Unable to find path separator - %s", fl_global.current_path);
            return;
        } 
		//root dir
        else if (last_separator == fl_global.current_path) {
            //fl_global.current_path[4] = '\0';   //alterac moid  1
        } 
        else {
            *last_separator = '\0';
        }
        filelist_clear_list();
        filelist_get_list(fl_global.current_path);
        fl_global.status_changed = 1;
    }

}

void filelist_move_right()
{
    char temp_path[PATH_MAX];
    int i = fl_global.current_list_start+fl_global.current_highlight;
    
    sound_out( DECIDE );
    
    if (S_ISDIR(fl_global.statlist[i].st_mode) && !is_back_dir(fl_global.namelist[i])) 
    {
        strcpy(temp_path, fl_global.current_path);
        if (!ends_with_slash(fl_global.current_path)) 
        {
            strcat(temp_path, "/");
        }
        strcat(temp_path, fl_global.namelist[i]->d_name);
        filelist_clear_list();
        if (filelist_get_list(temp_path) != 0)
        {
            filelist_get_list(fl_global.current_path);
        }
        fl_global.status_changed = 1;
    }
} 

void filelist_changedir(Direction dir) 
{
    if (fl_global.can_change_dir) 
    {
        dir == PREV ? filelist_move_left() :filelist_move_right();
    }
}

void filelist_store_dir()
{
    if (fl_global.can_change_dir && can_write_fs()) 
    {
        conf_dirselect(menu_active_item_config, fl_global.current_path);
    }
}

//alterac add 
extern SDL_Surface* screen;
extern SDL_Surface* online_bk_face;
extern SDL_Surface* online_item_face;
extern int number_of_menu;
extern int* number_of_menuitem;
extern int number_of_submenuitem;
int exp_curindex = 0;
int online_curindex = 0;
#if 1
void appdesc_init(char* suffixname,char* exename,char* workdir)
{
		cfg_t*  menu_config_new;	
		cfg_t* menu_item_config_new;
		cfg_t*  menu_subitem_config_new;	
		int number_of_submenuitem_new;
		char* str_tmp = NULL;


		printf("number_of_menu  = %d\n",number_of_menu);
		int i,j,k;
		if ((number_of_menu) > 0){
			for(i=0;i<number_of_menu;i++){
				menu_config_new  = cfg_getnsec(cfg, "Menu", i);
				if (number_of_menuitem[i] == 0){
					continue;
				}else{
					for(j=0;j<number_of_menuitem[i];j++){
						menu_item_config_new = cfg_getnsec(menu_config_new, "MenuItem", j);
						number_of_submenuitem_new = cfg_size(menu_item_config_new,"SubMenuItem");
						if (number_of_submenuitem_new == 0){
							str_tmp = cfg_getstr(menu_item_config_new,"Selectformat");
							max_to_min(str_tmp);
							if (str_tmp != NULL){
								if (strstr(str_tmp,suffixname)){
									strncpy(exename,cfg_getstr(menu_item_config_new,"Executable"),512);
									strncpy(workdir,cfg_getstr(menu_item_config_new,"WorkDir"),1024);
									return;
								}
							}
						}else{
							for(k=0;k<number_of_submenuitem_new;k++){
								menu_subitem_config_new = cfg_getnsec(menu_item_config_new, "SubMenuItem", k);
								str_tmp = cfg_getstr(menu_subitem_config_new,"Selectformat");
								max_to_min(str_tmp);
								if (str_tmp != NULL){
									//if (strncasecmp(suffixname,"gb") == 0){
									//}
									if (strstr(str_tmp,suffixname)){
										strncpy(exename,cfg_getstr(menu_subitem_config_new,"Executable"),512);
										strncpy(workdir,cfg_getstr(menu_subitem_config_new,"WorkDir"),1024);
										return;
									}
								}
							}
						}
					}
				}
			}
		}
}
#else
void appdesc_init()
{
	strncpy(appname[0].appexename,"./nxu.dge",256);
}
#endif
TTF_Font* menuitem_font;
void ExpDrawSubMenu()
{
	//	SDL_Color text_color = {0,255,0};
	SDL_Color* text_color = get_theme_font_color();
		int lang_value = get_sys_language();
		printf("lang_value = %d\n",lang_value);
		filelist_draw(screen);
		filelist_osd(screen);
		int x = (SCREEN_WIDTH - exp_bk_face->w)/2;
		int y = (SCREEN_HEIGHT - exp_bk_face->h)/2;
		Apply_surface(x,y,exp_bk_face,screen,NULL);
		Apply_surface(x,y+5+30*exp_curindex,exp_item_face,screen,NULL);
		SDL_Surface* text_face1 = NULL;
		SDL_Surface* text_face2 = NULL;
		text_face1 = TTF_RenderUTF8_Blended(menuitem_font,res_open[lang_value],*text_color);	
		text_face2 = TTF_RenderUTF8_Blended(menuitem_font,res_delete[lang_value],*text_color);	
		if (!text_face1 || !text_face2){
			printf("Failed to load ttf text!\n");
			return;
		}
		sdlDrawText((SCREEN_WIDTH - exp_bk_face->w - text_face1->w)/2 + 50,y+5,res_open[lang_value],*text_color,screen);
		sdlDrawText((SCREEN_WIDTH - exp_bk_face->w - text_face2->w)/2 + 50,y+35,res_delete[lang_value],*text_color,screen);
		if (text_face1 && text_face2)
		SDL_FreeSurface (text_face1);
		SDL_FreeSurface (text_face2);
		SDL_Flip(screen);
	//	SDL_SaveBMP(screen,"/usr/local/dmenu/test.bmp");
	//	while(1);

}
char* get_file_suffix(char* filename)
{
		char* str_tmp =	strrchr(filename,'.');
		return str_tmp;
}
int psxdge_is_exist(void)
{
  int ret = 0;
#define PSXDEG_FILE "/mnt/memory/emulator/psx.dge"
#define PSXBIOS_FILE "/mnt/memory/emulator/scph1001.bin"
  if(access(PSXDEG_FILE,F_OK) == 0)
  {
    if(access(PSXBIOS_FILE,F_OK) == 0)
    {
      printf("psx is f_ok\n");
      return 1;
    }
  }
  printf("psx is not f_ok\n");

  return ret;
}
void ExpSubMenuProc(char* filename)
{
	isDrawFlag = 0;
	SDLKey key;
	char tmp_str[4096];
	char str_exename[512];
	char str_workdir[1024];
	int program_done = 1;
	SDL_Event event;
	SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY,SDL_DEFAULT_REPEAT_INTERVAL);//set delay to 0 disables  key repeat
	memset(tmp_str,0,4096);
	memset(str_exename,0,512);
	memset(str_workdir,0,1024);
	while(program_done){
		if (SDL_PollEvent(&event)){
			if (event.type == SDL_KEYDOWN){
				key = event.key.keysym.sym;
				switch(key)
				{
					case DINGOO_BUTTON_UP:   
						exp_curindex --;
						if (exp_curindex < 0)
							exp_curindex = 1;
						fl_global.status_changed = 1;
						ExpDrawSubMenu();
						break;
					case DINGOO_BUTTON_DOWN: 
						exp_curindex ++;
						if (exp_curindex > 1)
							exp_curindex = 0;
						fl_global.status_changed = 1;
						ExpDrawSubMenu();
						break;
					case DINGOO_BUTTON_A:                                        //ok
						if (exp_curindex == 0){
							char* str_name = new_str(strlen(filename)+1);
							strcpy(str_name,filename);
							max_to_min(str_name);
							char* str_suffix = get_file_suffix(str_name);
							if (!strcasecmp(str_suffix,".dge")){
								if (get_mode_state()==0){
									//stop_flush_screen();
									//SDL_Delay(200);
									//set_a320_mode();
									system("/usr/local/dmenu/A320_close.sh");
								}
								else if (get_mode_state() == 1){
									//printf("==============%s    %d   ==========  \n",__FILE__,__LINE__);
									system("/usr/local/dmenu/A320_zoom_out.sh");}
								else system("/usr/local/dmenu/A320_zoom_in.sh");
								isOpenScreen = 1;
								free_erase(str_name);
								run_command(filename, NULL, fl_global.current_path);
							}else if (!strcasecmp(str_suffix,".zip")){
								//	free_erase(str_name);
								//	run_command("./mame.dge", filename,"/boot/game/mame");
								free_erase(str_name);
								program_done = 0;
								fl_global.status_changed = 1;
								break;
							}else if(strcasecmp(str_suffix,".gb") == 0){
								free_erase(str_name);
								run_command("./gbcgb_emu.dge", filename,"/boot/game/gbc");
                                                        }else if(strcasecmp(str_suffix,".bin") == 0){
                                                                printf("open bin file try to use psx.dge!!!");
								free_erase(str_name);
                                                                if(psxdge_is_exist())
                                                                {
								  run_command("./psx.dge", filename,"/mnt/memory/emulator");
                                                                }else
                                                                {
                                                                  free_erase(str_name);
                                                                  program_done = 0;
                                                                  fl_global.status_changed = 1;
                                                                  break;
                                                                }
							}else if(strcasecmp(str_suffix,".cbn") == 0){
                                                                printf("open cbn file try to use psx.dge!!!");
								free_erase(str_name);
                                                                if(psxdge_is_exist())
                                                                {
                                                                  run_command("./psx.dge", filename,"/mnt/memory/emulator");
                                                                }else
                                                                {
                                                                  free_erase(str_name);
                                                                  program_done = 0;
                                                                  fl_global.status_changed = 1;
                                                                  break;
                                                                }
							}
                                                        else{
								appdesc_init(str_suffix,str_exename,str_workdir);
								printf("strsuffix = %s strexename = %s strworkdir = %s\n",str_suffix,str_exename,str_workdir);
								free_erase(str_name);
								if (str_exename[0] == 0 || str_workdir[0] == 0){
									program_done = 0;
									fl_global.status_changed = 1;
									break;
								}else{
									run_command(str_exename, filename,str_workdir);
								}
							}
							isDrawFlag = 1;
						}
						else if (exp_curindex == 1){
							remove(filename);
							sync();
							if (strstr(filename,"mmc") != NULL){
								printf("flush mmcblk0!\n");
								flush_block("/dev/mmcblk0");
							}else{
								printf("flush mtdblock5!\n");
								flush_block("/dev/mtdblock5");
							}
							SDL_Delay(2000);
							filelist_clear_list();
							filelist_get_list(fl_global.current_path);
							fl_global.status_changed = 1;
						}
						set_timer();
						program_done = 0;
						break;
					case DINGOO_BUTTON_B:
						program_done = 0;
						fl_global.status_changed = 1;
						set_timer();
						break;
					default: 	break;
				}
			}
			else if (event.type == SDL_QUIT){
				program_done = 0;
						set_timer();
			}
		}
	}

}


void draw_online_menu()
{
	SDL_Color* text_color = get_theme_font_color();
	SDL_Surface* tmp_face = NULL;
	int lang_value = get_sys_language();
	Apply_surface(0,0,background,screen,NULL);
	Apply_surface((SCREEN_WIDTH-online_bk_face->w)/2,(SCREEN_HEIGHT-online_bk_face->h)/2,online_bk_face,screen,NULL);
	int mid_x = draw_xmid_text((SCREEN_HEIGHT - online_bk_face->h)/2+30,res_single[lang_value],*text_color,screen);
	//sdlDrawRect((SCREEN_WIDTH-160)/2,(SCREEN_HEIGHT-142)/2+10+50*online_curindex,160,20,32,0xffffff,0xaf,screen);	
	Apply_surface(SCREEN_WIDTH/2 - online_item_face->w/2,(SCREEN_HEIGHT-online_bk_face->h)/2+30+50*online_curindex,online_item_face,screen,NULL);
	draw_xmid_text((SCREEN_HEIGHT - online_bk_face->h)/2+80,res_create[lang_value],*text_color,screen);
	draw_xmid_text((SCREEN_HEIGHT - online_bk_face->h)/2+130,res_search[lang_value],*text_color,screen);
	free_color(text_color);
	SDL_Flip(screen);
}
void draw_low_power()
{
	SDL_Color text_color = {255,0,0};
	SDL_Surface* tmp_face = NULL;
	int lang_value = get_sys_language();
	draw_xmid_text((SCREEN_HEIGHT - 20)/2,res_low_power[lang_value],text_color,screen);
	SDL_Flip(screen);
}

#if P2P_CONNECT

void sound_close()
{
	Mix_HaltChannel(-1);
	Mix_CloseAudio();
}

void sound_open()
{
	if(Mix_OpenAudio(MIX_DEFAULT_FREQUENCY,MIX_DEFAULT_FORMAT,2,1024)<0) {
		printf("Can't initialize Sounds.\n");
	}
}

void online_key_proc(char* name)
{
	
	isDrawFlag = 0;
	SDLKey key;
	int program_done = 1;
	SDL_Event event;
	SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY,SDL_DEFAULT_REPEAT_INTERVAL);//set delay to 0 disables  key repeat
	while(program_done){
		if (SDL_PollEvent(&event)){
			if (event.type == SDL_KEYDOWN){
				key = event.key.keysym.sym;
				switch(key)
				{
					case DINGOO_BUTTON_UP:   
						sound_out( MENUITEM_MOVE );
						online_curindex --;
						if (online_curindex < 0)
							online_curindex = 2;
						draw_online_menu();
						//fl_global.status_changed = 1;
						break;
					case DINGOO_BUTTON_DOWN: 
						sound_out( MENUITEM_MOVE );
						online_curindex ++;
						if (online_curindex > 2)
							online_curindex = 0;
						draw_online_menu();
						//fl_global.status_changed = 1;
						break;
					case DINGOO_BUTTON_A:                                        //ok
						sound_out(DECIDE);
						fl_global.status_changed = 0;
						if (online_curindex == 0){
							single_flag = 1;
							isDrawFlag = 1;
							program_done = 0;
							set_timer();
							break;
						}

						if (handle_value == 1){
							break;
						}
						//
						if (get_low_flag() == 1){
							draw_low_power();
							SDL_Delay(2000);
						}

						if (online_curindex == 1){
							sound_close();
							server_flag = p2p_main(0);
						}

						if (online_curindex == 2){
							sound_close();
							client_flag = p2p_main(1);
						}

						if (server_flag < 0 && client_flag < 0){
							draw_online_menu();
							sound_open();
						}
						else if (server_flag == 0 || client_flag == 0){
							isDrawFlag = 1;
							program_done = 0;
							set_timer();
						}
						break;
					case DINGOO_BUTTON_B:
						single_flag = 0;
						server_flag = -1;
						client_flag = -1;
						program_done = 0;
						set_timer();
						fl_global.status_changed = 1;
						break;
					default: 	break;
				}
			}
			else if (event.type == SDL_QUIT){
				program_done = 0;
						set_timer();
			}
		}
	}

}
#else
void online_key_proc(char* name)
{
	
	isDrawFlag = 0;
	SDLKey key;
	int program_done = 1;
	SDL_Event event;
	SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY,SDL_DEFAULT_REPEAT_INTERVAL);//set delay to 0 disables  key repeat
	while(program_done){
		if (SDL_PollEvent(&event)){
			if (event.type == SDL_KEYDOWN){
				key = event.key.keysym.sym;
				switch(key)
				{
					case DINGOO_BUTTON_UP:   
						online_curindex --;
						if (online_curindex < 0)
							online_curindex = 2;
						draw_online_menu();
						//fl_global.status_changed = 1;
						break;
					case DINGOO_BUTTON_DOWN: 
						online_curindex ++;
						if (online_curindex > 2)
							online_curindex = 0;
						draw_online_menu();
						//fl_global.status_changed = 1;
						break;
					case DINGOO_BUTTON_A:                                        //ok
						fl_global.status_changed = 0;
						if (online_curindex == 0){
							single_flag = 1;
							isDrawFlag = 1;
							program_done = 0;
							set_timer();
							break;
						}
						if (handle_value == 1){
							break;
						}
						//
						if (get_low_flag() == 1){
							draw_low_power();
							SDL_Delay(2000);
						}
						if (online_curindex == 1){
							server_flag = server(screen,name);
						}
						if (online_curindex == 2){
							client_flag = client(screen,name);
						}
						if (server_flag == 0 && client_flag == 0)
							draw_online_menu();
						else{
							isDrawFlag = 1;
							program_done = 0;
							set_timer();
						}
						break;
					case DINGOO_BUTTON_B:
						single_flag = 0;
						server_flag = 0;
						client_flag = 0;
						program_done = 0;
						set_timer();
						fl_global.status_changed = 1;
						break;
					default: 	break;
				}
			}
			else if (event.type == SDL_QUIT){
				program_done = 0;
						set_timer();
			}
		}
	}

}
#endif

//end

// Since filelist_run() has multiple purpose, the next state
// need to be returned from this function.
MenuState filelist_run()
{
#if ELAN_CONNECT
	server_flag = 0;
	client_flag = 0;
	single_flag = 0;
#elif P2P_CONNECT
	server_flag = -1;
	client_flag = -1;
	single_flag = 0;
#endif
	char file_name[PATH_MAX];
	int i = fl_global.current_list_start+fl_global.current_highlight;

    if (fl_global.can_change_dir && S_ISDIR(fl_global.statlist[i].st_mode)) 
    {
        filelist_changedir(is_back_dir(fl_global.namelist[i])?PREV:NEXT);
        return FILELIST;
    }

	//write file list
    //write_filelist(fl_global.current_path);
    
	strcpy(file_name, fl_global.current_path);
    if (!ends_with_slash(fl_global.current_path)) 
    {
        strcat(file_name, "/");
    }
    strcat(file_name, fl_global.namelist[i]->d_name);
    

	//alterac add  for set cpu  freq
	int app_freq = active_conf_int("Freq");
	printf("app freq value = %d\n",app_freq);
	set_cpu_freq(app_freq);
	old_state = 1; 
	old_list_start = fl_global.current_list_start;
	old_highlight = fl_global.current_highlight;
	//end
    // If this is theme selection, we will return here from run_command();
    // If it's running a program, it will not return.
    if (fl_global.current_executable[0] != '\0') 
    {
#if ELAN_CONNECT 
	//write_file_list();
		if (strstr(fl_global.current_executable,"nxu") != 0 || strstr(fl_global.current_executable,"md_emu") != 0){
				printf("go to online\n");
				draw_online_menu();
				online_key_proc(file_name);
				if (server_flag > 0 || client_flag > 0 || single_flag == 1){ 
						printf("run command!\n");
	 					run_command(fl_global.current_executable, file_name, fl_global.work_path);
				}
		}else{
	 			run_command(fl_global.current_executable, file_name, fl_global.work_path);
		}
#elif P2P_CONNECT
		if (strstr(fl_global.current_executable,"nxu") != 0 || strstr(fl_global.current_executable,"md_emu") != 0
				|| strstr(fl_global.current_executable,"fc_emu") != 0){

			if(strstr(fl_global.current_executable,"sfc_emu") != 0)
			{
				run_command(fl_global.current_executable, file_name, fl_global.work_path);
				return FILELIST;
			}
			printf("go to online\n");
			draw_online_menu();
			online_key_proc(file_name);
			if (server_flag == 0 || client_flag == 0 || single_flag == 1){ 
				printf("run command!\n");
				run_command(fl_global.current_executable, file_name, fl_global.work_path);
			}
		}else{
			run_command(fl_global.current_executable, file_name, fl_global.work_path);
		}
#else
	 			run_command(fl_global.current_executable, file_name, fl_global.work_path);
#endif
    }
	//exporle 
    else {
	//		remove_file_list();
			ExpDrawSubMenu();
			ExpSubMenuProc(file_name);
			//run_command(file_name, NULL, fl_global.current_path);
	}
	return FILELIST;
}

MenuState filelist_keypress(SDLKey key)
{
    Direction dir = getKeyDir(key);
    
    switch (key) 
    {
        case DINGOO_BUTTON_L:
        case DINGOO_BUTTON_R:
            filelist_move_page(dir);
            break;
        case DINGOO_BUTTON_UP:
        case DINGOO_BUTTON_DOWN:
            filelist_move_entry(dir);
            break;
        case DINGOO_BUTTON_LEFT:
        case DINGOO_BUTTON_RIGHT:
            filelist_changedir(dir);
            break;
        case DINGOO_BUTTON_START:
            //filelist_store_dir();
            break;
        case DINGOO_BUTTON_B:
			old_state = 0;
            filelist_deinit();
            return MAINMENU;
        case DINGOO_BUTTON_A:
            return filelist_run();
        default:break;
    }

    return FILELIST;
}




