#include "loading.h"
#include "common.h"
#include "resource.h"
#include "env.h"


#define BACKGROUND_STR "Background"
#define LANGUAGE_PATH "/usr/etc/dmenu/dmenu.ini"
SDL_Surface* loading_bg;
SDL_Surface* loading_status_bg;
SDL_Surface* loading_status_fg;
SDL_Surface* loading_screen;
//SDL_Surface* loading_text;
char tmp_str[256];
char* get_sys_background_dir(void)
{
		FILE *fd;
		int ret = 0;
		fd = fopen(LANGUAGE_PATH,"rb");
		if (fd == NULL){
			return NULL;
		}
		int i = 0;
		char* file_buf = NULL;
		char* line_buf = NULL;
		char* tmp_buf = NULL;
		int cur_size;
		fseek(fd,0,SEEK_END);
		int file_size = ftell(fd);
		fseek(fd,0,SEEK_SET);
		if (file_size == 0)
		{
				fclose(fd);
				return NULL;
		}
		file_buf = (char*)malloc(file_size);
		if (file_buf == NULL){
				fclose(fd);
				return NULL;
		}
		fread(file_buf,1,file_size,fd);
		fclose(fd);
		line_buf = strstr(file_buf,BACKGROUND_STR);
		if (line_buf == NULL){
				free(file_buf);
				return NULL;
		}
		tmp_buf = strchr(line_buf,'\n');
		line_buf[tmp_buf-line_buf-1] = '\0';
		tmp_buf = strchr(line_buf,'/');
		if (tmp_buf == NULL){
				free(file_buf);
				return NULL;
		}
		strncpy(tmp_str,tmp_buf,256);
		free(file_buf);
		return tmp_str;
}

void loading_init(SDL_Surface* screen) 
{
		char* sys_background_dir;
		sys_background_dir = get_sys_background_dir();
		if (sys_background_dir != NULL)
		printf("back gound dir is %s\n",sys_background_dir);
		else
		printf("back gound dir is null\n");

		loading_screen = screen;
		if (access(IMG_MAIN_BK,0) == 0){
				loading_bg = load_image_file_no_alpha(IMG_MAIN_BK);
		}else{		
				if (sys_background_dir != NULL){
						loading_bg = load_image_file_no_alpha(sys_background_dir);
				}else{
						loading_bg = load_global_image("loading.png");
				}
		}

		//loading_text = draw_text(); 
    loading_start();
}
void loading_init_video(SDL_Surface* screen) 
{
    loading_screen = screen;
    loading_bg = load_global_image("real.png");
    SDL_BlitSurface(loading_bg, NULL, loading_screen, NULL);
}
void loading_init_other(SDL_Surface* screen) 
{
    loading_screen = screen;
    loading_bg = load_global_image("loading.png");
    SDL_BlitSurface(loading_bg, NULL, loading_screen, NULL);
}


void loading_start() 
{
	SDL_BlitSurface(loading_bg, NULL, loading_screen, NULL);
	SDL_Flip(loading_screen);
}

void loading_deinit()
{
    free_surface(loading_bg);
    free_surface(loading_status_bg);
    free_surface(loading_status_fg);
}
