/*
 *  Copyright (C) 2009 Rookie1 <mr.rookie1@gmail.com>
 *                     sca <scahoo <at> gmail <dot> com>
                       timothy.soehnlin <timothy.soehnlin@gmail.com>
 *
 *  Author: <mr.rookie1@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include <unistd.h>
#include <stdlib.h>
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_ttf.h>
#include <SDL_rotozoom.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include "menu.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "env.h"
#include "common.h"
#include "conf.h"
#include "dosd/dosd.h"
#include "resource.h"
#include "colorpicker.h"
#include "filelist.h"
#include "imageviewer.h"
#include "persistent.h"
#include "sound.h"
#include "dingoo.h"
#include "../version_git.h"

SDL_Surface ** circle;
extern cfg_t *cfg;
cfg_t *menu_config;
cfg_t *menu_item_config;
cfg_t *menu_subitem_config;
cfg_t *menu_active_item_config;

int menu_is_initted = 0;
int menu_text_pad_left = 0;
int menu_needs_redraw = 1; //First draw
SDL_Rect menu_active_rect;

SDL_Surface* background;

SDL_Surface** menu_icons;
SDL_Surface** menu_focus_icons;
SDL_Surface** menu_text;
int number_of_menu;

SDL_Surface*** menuitem_icons;
SDL_Surface*** menuitem_text;
int* number_of_menuitem;

SDL_Surface** submenuitem_icons;
SDL_Surface** submenuitem_text;
int number_of_submenuitem;

SDL_Surface* tmp_surface;SDL_Surface* focus_surface;
int current_menu_index;
int current_menu_offset, current_menu_offset_step; //used for animation
int current_menuitem_offset, current_menuitem_offset_step; //used for animation
int current_submenuitem_offset, current_submenuitem_offset_step; //used for animation
int current_menuitem_index;
int current_submenuitem_index;

 char handle_value = 0;
TTF_Font* menu_font;
TTF_Font* menuitem_font;
SDL_Surface * online_bk_face;
SDL_Surface * online_item_face;
SDL_Surface * exp_bk_face;
SDL_Surface * exp_item_face;
SDL_Surface * handle_face;
SDL_Surface * sub_item_focus_face;
SDL_Surface * udc_face;
SDL_Surface * udc_wait_textface;
SDL_Surface * udc_fail_face;
SDL_Surface * udc_tip_textface;
char file_format[FORMAT_MAX];
char gsensor_open_flag;
char old_state = 0;
static int cfg_flag = 0;
static int sub_draw_flag;
int a320_mode_flag = 0;
static int unlock_success=0;
static int unlock_flag=0;
int unlock_to_game;

extern char filelist_path[PATH_MAX];

extern MenuState state;

extern const char* res_about[MAX_LAN] ;
extern const char* res_mode[MAX_LAN] ;
extern const char* res_totalsize[MAX_LAN] ;
extern const char* res_availablesize[MAX_LAN] ;
extern const char* res_version[MAX_LAN] ;
extern const char* res_[MAX_LAN] ;
extern const char* res_unlock_info[MAX_LAN];
extern const char* res_unlock_ok[MAX_LAN];
extern const char* res_lock_info[MAX_LAN];
extern const char* res_lock_ok[MAX_LAN];
extern const char* res_code_symbol[13];
//alterac add

int get_unlock_flag()
{
	return unlock_flag;
}

int get_unlock_for_game()
{
	return unlock_to_game;
}

int get_mode_state()
{
	return a320_mode_flag;
}
void set_mode_state(int key)
{
	a320_mode_flag = key;
}

int get_sysabout_flag()
{
		return cfg_flag;
}
void set_sysabout_flag()
{
		cfg_flag = 0;
}
SDL_Surface* DebugIMGLoad(char* dirname,int alpha)
{
	SDL_Surface* out = NULL;
	SDL_Surface* tmp_face = NULL;
	tmp_face = IMG_Load(dirname);
	if (!tmp_face){
		printf("Failed to load %s: %s",dirname,IMG_GetError());
		return NULL;
	}
	if (alpha)
		out = SDL_DisplayFormatAlpha(tmp_face);
	else
		out = SDL_DisplayFormat(tmp_face);
	SDL_FreeSurface(tmp_face);
	return out;
}

void get_circle_face()
{
#if 1
	int i;
	for(i = 0;i<11;i++) {
		circle[i] = NULL;
	}
	circle[0] = DebugIMGLoad (MOVE1,1);
	circle[1] = DebugIMGLoad (MOVE2,1);
	circle[2] = DebugIMGLoad (MOVE3,1);
	circle[3] = DebugIMGLoad (MOVE4,1);
	circle[4] = DebugIMGLoad (MOVE5,1);
	circle[5] = DebugIMGLoad (MOVE6,1);
	circle[6] = DebugIMGLoad (MOVE7,1);
	circle[7] = DebugIMGLoad (MOVE8,1);
	circle[8] = DebugIMGLoad (MOVE9,1);
	circle[9] = DebugIMGLoad (MOVE10,1);
	circle[10] = DebugIMGLoad (MOVE11,1);
#endif
}
//add end

void menu_reload_background() 
{
		free_surface(background);
		if ((background = load_image_file_no_alpha(IMG_MAIN_BK)) == NULL){
				background = get_theme_background();
				if (background == NULL){
						background = DebugIMGLoad(WALLP_PIC,1);
				}
		}
}

void menu_reload_handle() 
{
#if 1
    free_surface(handle_face);
	handle_face = DebugIMGLoad (HANDLE_PIC,1);
    free_surface(online_bk_face);
	online_bk_face = DebugIMGLoad (ONLINE_BK_PIC,1);
    free_surface(online_item_face);
	online_item_face = DebugIMGLoad (ITEM_BK_PIC,1);
    free_surface(exp_bk_face);
	exp_bk_face = DebugIMGLoad (EXP_BK_PIC,1);
    free_surface(exp_item_face);
	exp_item_face = DebugIMGLoad (EXP_ITEM_PIC,1);
    free_surface(sub_item_focus_face);
	sub_item_focus_face = DebugIMGLoad (MORE_FOCUS_PIC,1);
#endif
}
void menu_reload_udc(SDL_Color* color) 
{
#if 1
    free_surface(udc_face);
   // free_surface(udc_wait_textface);
	udc_face = DebugIMGLoad (USB_PIC,1);
	//udc_wait_textface = draw_text(cfg_getstr(cfg,"UdcWaitText"),menu_font,color);
	//udc_fail_face = draw_text(cfg_getstr(cfg,"UdcFailText"),menu_font,color);
	//udc_tip_textface = draw_text(cfg_getstr(cfg,"UdcTipText"),menu_font,color);
#endif
}

void menu_state_changed()
{
    menu_needs_redraw = 1;
}

void menu_update_items()
{
    menu_config  = cfg_getnsec(cfg, "Menu", current_menu_index);
    menu_item_config = cfg_getnsec(menu_config, "MenuItem", current_menuitem_index);
    
    if (number_of_submenuitem > 0) 
    {
        menu_subitem_config = cfg_getnsec(menu_item_config, "SubMenuItem", current_submenuitem_index);
    } 
    else {
        menu_subitem_config = NULL;
    }
    menu_active_item_config = (menu_subitem_config == NULL) ? menu_item_config : menu_subitem_config;
}
    
void menu_get_position(char* dirname,char* menu_name, char* menu_item_name, char* menu_subitem_name)
{
    char* c;
    menu_update_items();
	//alterac add
	int str_len = strlen(filelist_path);
	strncpy(dirname,filelist_path,(str_len+1) > 2048 ? 2048 : (str_len+1));
	//end
    copyname_trim(menu_name, menu_config);
    copyname_trim(menu_item_name, menu_item_config);
    copyname_trim(menu_subitem_name, menu_subitem_config);
    log_debug("Saving Position As: %s(%d), %s(%d), %s(%d)", 
        menu_name,current_menu_index, 
        menu_item_name,current_menuitem_index, 
        menu_subitem_name,current_submenuitem_index);
}

void menu_set_position(int start,int highlight,char menu_state,const char* dirname,const char* menu_name, const char* menu_item_name, const char* menu_subitem_name) 
{
    log_debug("Trying to load: %s, %s, %s", menu_name, menu_item_name, menu_subitem_name);
    
    cfg_t *m, *mi, *smi;
    int i=-1,j=-1,k=-1,n=0;
    char *c;
    int has_sub = menu_subitem_name[0] != '\0';
    for (i=0;i<number_of_menu;i++) {
        m = cfg_getnsec(cfg, "Menu", i);
        if_names_equal(m, menu_name) {
            for (j=0;j<number_of_menuitem[i];j++) {
                mi = cfg_getnsec(m, "MenuItem", j);
                if_names_equal(mi, menu_item_name) {
                    if (has_sub) {
                        n = cfg_size(mi, "SubMenuItem");
                        for (k=0;k<n;k++) {
                            smi = cfg_getnsec(mi, "SubMenuItem", k);
                            if_names_equal(smi, menu_subitem_name) break;
                        }    
                    }
                    break;
                }
            }
            break;
        }
    }
    
    if (!(i == number_of_menu || j == number_of_menuitem[i] || (k>=0 && k==n))) 
    {
		//Restore menu
		current_menu_index = i;
		current_menuitem_index = j;
		if (has_sub) {
				menu_update_items();
				menu_open_sub();
				current_submenuitem_index = k;
		}

		printf("menu_state = %d   dirname = %s\n",menu_state,dirname);
		//alterac add
		if (menu_state == 1 && dirname != NULL){
			menu_update_items();
			char* format = active_conf_str("Selectformat");
			int str_len = strlen(format);
			memset(file_format,0,FORMAT_MAX);
			memcpy(file_format,format,(str_len+1)>FORMAT_MAX ? FORMAT_MAX : (str_len+1));
			reinit_flglobal(start,highlight);
			if (!filelist_init(
						active_conf_str("Name"),    active_conf_str("Executable"),
						active_conf_str("WorkDir"),dirname, 1))
			{
				state = FILELIST;
			}

		}
		//end
    }
}

int menu_init()
{
	unsigned char buff[32] = {0};
	if (menu_is_initted) return 0;
	menu_is_initted = 1;

	memset(filelist_path,0,PATH_MAX);

	int i, j;
	SDL_Color* color = get_theme_font_color();
	menu_reload_background();
	//alterac add
	menu_reload_handle();
	//end

	//alterac add	
	init_flglobal();
	//end
	current_menu_index = 0;
	current_menu_offset = 0;
	current_menuitem_index = 0;
	current_menuitem_offset = 0;
	current_submenuitem_index = 0;
	current_submenuitem_offset = 0;

	// load font
	menu_font     = get_theme_font(MENU_TEXT_FONT_SIZE);
	menuitem_font = get_theme_font(MENU_ITEM_FONT_SIZE);
	//TTF_SetFontStyle(menu_font,TTF_STYLE_BOLD);
	//TTF_SetFontStyle(menuitem_font,TTF_STYLE_BOLD);

	// load menu
	number_of_menu     = cfg_size(cfg, "Menu");
	number_of_menuitem = new_array(int, number_of_menu);
	menu_icons         = new_array(SDL_Surface*,  number_of_menu);
	menu_focus_icons   = new_array(SDL_Surface*,  number_of_menu);
	circle   	   = new_array(SDL_Surface*,  11);
	menu_text          = new_array(SDL_Surface*,  number_of_menu);
	menuitem_icons     = new_array(SDL_Surface**, number_of_menu);
	menuitem_text      = new_array(SDL_Surface**, number_of_menu);
	menu_text_pad_left = cfg_getint(cfg, "ItemTextPadLeft");
	printf("1111111111111111111\n");

	//alterac  add
	get_circle_face();
	menu_reload_udc(color);
	//end
	for (i=0;i<number_of_menu;i++) {
		menu_config = cfg_getnsec(cfg, "Menu", i);
		menu_icons[i] = load_theme_image(cfg_getstr(menu_config, "Icon"));
		menu_focus_icons[i] = load_theme_image(cfg_getstr(menu_config, "Icon_focus"));
		menu_text[i]  = draw_text(cfg_getstr(menu_config, "Name"), menu_font, color);

		number_of_menuitem[i] = cfg_size(menu_config, "MenuItem");
		menuitem_icons[i] = new_array(SDL_Surface*, number_of_menuitem[i]);
		menuitem_text[i]  = new_array(SDL_Surface*, number_of_menuitem[i]);

		for (j=0;j<number_of_menuitem[i];j++) {
			menu_item_config = cfg_getnsec(menu_config, "MenuItem", j);
			menuitem_icons[i][j] = load_theme_image(cfg_getstr(menu_item_config, "Icon")); 
			menuitem_text[i][j]  = draw_text(cfg_getstr(menu_item_config, "Name"), menuitem_font, color);
		}
	}

	free_color(color);
	persistent_restore_menu_position();

#if 0
	if (handle_value == 1){
		FILE* fp;
		i = 3;
		fp = fopen("/proc/jz/elan_pad","w");
		if (fp != NULL){
			sprintf(buff,"%d",i);
			fwrite(buff,32,1,fp);
			//fflush(fp);
			//fsync(fp);
			fclose(fp);
		}
	}else{
		FILE* fp;
		i = 0;
		fp = fopen("/proc/jz/elan_pad","w");
		if (fp != NULL){
			sprintf(buff,"%d",i);
			fwrite(buff,32,1,fp);
			//fflush(fp);
			//fsync(fp);
			fclose(fp);
		}

	}
#endif

	return 0;
}

void menu_deinit()
{
    if (!menu_is_initted) return;
    menu_is_initted = 0;
    
    log_debug("De-initializing");
    
    int i, j;
    
    free_surface(background);
    
    for (i=0;i<number_of_menu;i++) {
        SDL_FreeSurface(menu_icons[i]);
        SDL_FreeSurface(menu_focus_icons[i]);
        SDL_FreeSurface(menu_text[i]);
        for (j=0;j<number_of_menuitem[i];j++) {
            free_surface(menuitem_icons[i][j]);
            free_surface(menuitem_text[i][j]);
        }
        free_erase(menuitem_icons[i]);
        free_erase(menuitem_text[i]);
    }
#if 1
for (i = 0;i < 11;i++){   //alterac  add   for circle
		SDL_FreeSurface(circle[i]);
}

    free_surface(sub_item_focus_face);
    free_surface(handle_face);
    free_surface(online_bk_face);
    free_surface(online_item_face);
    free_surface(exp_bk_face);
    free_surface(exp_item_face);
    free_surface(udc_face);
    free_surface(udc_wait_textface);
    free_surface(udc_fail_face);
    free_surface(udc_tip_textface);
#endif
    free_erase(menuitem_icons);
    free_erase(menuitem_text);
    free_erase(number_of_menuitem);
    free_erase(menu_icons);
    free_erase(menu_focus_icons);
    free_erase(circle);
    free_erase(menu_text);

    free_font(menu_font);
    free_font(menuitem_font);
    
    // Save current menu state
    persistent_store_menu_position();
    
    if (number_of_submenuitem > 0) menu_close_sub();
}

//Draw single menu item
void menu_draw_single_item(
    SDL_Surface* screen,
    SDL_Surface* icon, SDL_Rect* icon_rect, 
    SDL_Surface* text, SDL_Rect* text_rect,
    int alpha, int text_position) 
{
    if (text_position >= 0) {
        if (text_position == 0) {
            text_rect->x = (icon_rect->x + icon->w) + menu_text_pad_left;
            text_rect->y = icon_rect->y + icon->h/2 - text->h/2;
        } else {
            text_rect->x = icon_rect->x + icon->w/2 - text->w/2;
            text_rect->y = icon_rect->y + icon->h; 
        }

        blitSurfaceAlpha(text, NULL, screen, text_rect, alpha);
    }

    blitSurfaceAlpha(icon, NULL, screen, icon_rect, alpha);
}


//Draw vertical menu items
void menu_draw_vitems(
    SDL_Surface* screen, SDL_Rect* offset, 
    SDL_Surface** icons, SDL_Rect* icon_rect, 
    SDL_Surface** text,  SDL_Rect* text_rect, 
    int current_item,    int number_of_items, 
    int child_showing,   int is_parent, int lower_offset) {
  
    int draw_item = 0, alpha = 0, ypos = 0;
    SDL_Rect clip_rect;

    //Update vertical offset
    int saved_offset_y = offset->y;
    offset->y += current_menuitem_offset;
    
    icon_rect->x = offset->x;

    if (number_of_items > 0 ) {

        // draw upper items 
        draw_item = current_item - 1;
        
        if (current_item > 0 && !child_showing) {

            //Set clipping rectangle before blit
            clip_rect.x = 0;
            clip_rect.y = 0;
            clip_rect.w = screen->w;
            clip_rect.h = saved_offset_y;
            SDL_SetClipRect(screen, &clip_rect);
            
            while (1) {
                
                alpha = item_alpha(current_item, draw_item); 
                icon_rect->y = offset->y - (current_item - draw_item)*icons[draw_item]->h;
                ypos = icon_rect->y; //icon_rect's position is overwritten by blitting 
                menu_draw_single_item(
                    screen, icons[draw_item], icon_rect,   
                    text[draw_item], text_rect,
                    alpha, child_showing ? -1 : 0);
                --draw_item; 
                if (ypos < 0 || draw_item < 0) break;
            }
        }

        // draw lower items 
        draw_item = current_item;
        icon_rect->y = offset->y + lower_offset;

        //Will store most recent active menu item (if submenu 
        //   is active, it will overwrite these values)
        menu_active_rect.x = icon_rect->x;
        menu_active_rect.y = icon_rect->y;

        //Set clipping rectangle before blit
        clip_rect.x = 0;
        clip_rect.y = saved_offset_y + lower_offset;
        clip_rect.w = screen->w;
        clip_rect.h = screen->h - clip_rect.y;
        SDL_SetClipRect(screen, &clip_rect);

        while (1) { 
            alpha = item_alpha(current_item, draw_item)>>(child_showing?1:0);
            //Do not highlight during scrolling animation
            if (alpha == MENU_ACTIVE_ALPHA && current_menuitem_offset != 0)
                alpha = item_alpha(0,1);
            ypos = icon_rect->y; //icon_rect's position is overwritten by blitting 
			if (number_of_submenuitem > 0 && sub_draw_flag == 1){
					if (draw_item == current_item){
							menu_draw_single_item(
											screen, 
											sub_item_focus_face, icon_rect, 
											text[draw_item], text_rect, 
											alpha, child_showing ? -1 : 0); 

					}else{
							menu_draw_single_item(
											screen, 
											icons[draw_item], icon_rect, 
											text[draw_item], text_rect, 
											alpha, child_showing ? -1 : 0); 
					}
			}else{
					menu_draw_single_item(
									screen, 
									icons[draw_item], icon_rect, 
									text[draw_item], text_rect, 
									alpha, child_showing ? -1 : 0); 

			}
			icon_rect->y = ypos + icons[draw_item]->h;
			draw_item++;
			alpha--;

			if (child_showing || icon_rect->y > screen->h || draw_item >= number_of_items) {
					break; //Only draw first item if child showing
            }
        }

        //Reset clipping rectangle after blit
        SDL_SetClipRect(screen, NULL);
    }
}

//Draw horizontal menu items
void menu_draw_hitems(
    SDL_Surface* screen, SDL_Rect* child_offset, 
    SDL_Surface** icons, SDL_Rect* icon_rect, 
    SDL_Surface** text,  SDL_Rect* text_rect, 
    int current_item, int number_of_items, int subchild_showing)
{
    int draw_item = current_item - 1;

    //Set menu horizontal offset
    icon_rect->x = current_menu_offset;

    //While there are empty slots to the left of the menu
    //   create a gap that is a single icon wide
    while (draw_item<0) {
        //icon_rect->x += icons[0]->w; 
        icon_rect->x += icons[0]->w  ; 
        draw_item++;
    }

    while (1) {
        int alpha = item_alpha(current_item, draw_item); 
        //Do not highlight during scrolling animation
        if (alpha == MENU_ACTIVE_ALPHA && current_menu_offset != 0)
            alpha = item_alpha(0,1);
        //We need to save the dest rect x position. SDL_BlitSurface will
        //update dest rect after clipping. If our x position is negative,
        //it will become 0 after this, which causes problem during
        //scrolling animation
        int saved_icon_rect_x = icon_rect->x;
	//alterac  add  for l008 cartoon
	if (draw_item == current_item){
	//if (0){
		//get_focus_mainmenu_surface(current_item);
		menu_draw_single_item(
				screen,
				menu_focus_icons[draw_item],icon_rect,
				text[draw_item],text_rect,
				alpha>>(subchild_showing?2:0),draw_item != current_item ? -1 : 1);			
	}else{
	//alterac add  end
        menu_draw_single_item(
            screen, 
            icons[draw_item], icon_rect, 
            text[draw_item],  text_rect, 
            alpha>>(subchild_showing?2:0), draw_item != current_item ? -1 : 1);
	}
        //Store calculated position for current menu items
        if (draw_item == current_item) { 
            init_rect_pos(child_offset, icon_rect->x, icon_rect->y);
        }

        //icon_rect->x = saved_icon_rect_x + icons[draw_item]->w;
        icon_rect->x = saved_icon_rect_x + icons[draw_item]->w ;

        draw_item++;
        
        if ((icon_rect->x >= screen->w) || (draw_item >= number_of_items)) break;
    }

}
int menu_draw(SDL_Surface* screen)
{
    if (!menu_needs_redraw) return 0;
    if (current_menu_offset == 0 && current_menuitem_offset == 0 &&
        current_submenuitem_offset == 0) {
        menu_needs_redraw = 0;
    }
    int subshow = number_of_submenuitem > 0;
	sub_draw_flag = 0;
    
    SDL_Rect icon_rect, text_rect, offset;

    init_rect_pos(&icon_rect, 0,0);
    init_rect_pos(&text_rect, 0,0);
    init_rect_pos(&offset, 0,0);
    //init_rect(&offset_screen, 0,0,400,240);
    
    // clear screen
	SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,0));  //alterac add
    SDL_BlitSurface(background, 0, screen, &offset);
    //SDL_BlitSurface(background, &offset_screen, screen, &offset_screen);
    //Set menu vertical offset
    icon_rect.y = (screen->h - menu_icons[0]->h - MENU_TEXT_HEIGHT) / 3; // assuming the font height for menu name is 20
    //icon_rect.y = (screen->h - menu_icons[0]->h - 15) / 3; // assuming the font height for menu name is 20

    //Draw main menu items
    menu_draw_hitems(
        screen, &offset, 
        menu_icons, &icon_rect, 
        menu_text, &text_rect, 
        current_menu_index,  number_of_menu, subshow); 

    //Do not draw menu item when we are scrolling
    if (current_menu_offset > 0) {
        current_menu_offset -= current_menu_offset_step;
        if (current_menu_offset < 0) current_menu_offset = 0;
        return 1;
    } else if (current_menu_offset < 0) {
        current_menu_offset += current_menu_offset_step;
        if (current_menu_offset > 0) current_menu_offset = 0;
        return 1;
    }

    //Draw menu items, starting at (x,y)
    menu_draw_vitems(
        screen, &offset, 
        menuitem_icons[current_menu_index], &icon_rect, 
        menuitem_text[current_menu_index], &text_rect, 
        current_menuitem_index, number_of_menuitem[current_menu_index],
        subshow, 1, menu_icons[current_menu_index]->h + MENU_TEXT_HEIGHT); 

    //Do not draw submenu item when we are scrolling the menu items
    if (current_menuitem_offset > 0) {
        current_menuitem_offset -= current_menuitem_offset_step;
        if (current_menuitem_offset < 0) current_menuitem_offset = 0;
        return 1;
    } else if (current_menuitem_offset < 0) {
        current_menuitem_offset += current_menuitem_offset_step;
        if (current_menuitem_offset > 0) current_menuitem_offset = 0;
        return 1;
    }

    //Draw submenu (will only show if it is active)
    // at this point, text_rect.x and text_rect.y should be at the position where we want to draw the current

    if (subshow) {
        int new_w = max(menuitem_icons[current_menu_index][current_menuitem_index]->w, menu_text[current_menu_index]->w);
        icon_rect.x += new_w;
        text_rect.x += new_w;
    }
    
    init_rect_pos(&offset, text_rect.x, text_rect.y+MENU_TEXT_HEIGHT); 
        
	sub_draw_flag = 1;
    menu_draw_vitems(
        screen, &offset, 
        submenuitem_icons, &icon_rect, 
        submenuitem_text, &text_rect, 
        current_submenuitem_index, 
        number_of_submenuitem, 0, 0, 0); 
                     
    return 1;
}

void menu_force_redraw(SDL_Surface* screen) {
    menu_needs_redraw = 1;
    menu_draw(screen);
}

void menu_animate(SDL_Surface* screen)
{
    /* Menu animation, but it isn't a good use
    
    static int animate_pos = 0;
    SDL_Surface *active_icon;
    if (number_of_submenuitem > 0) {
        active_icon = submenuitem_icons[current_submenuitem_index];
    } else {
        active_icon = menuitem_icons[current_menu_index][current_menuitem_index];
    }
    
    SDL_Rect rect = {menu_active_rect.x,menu_active_rect.y,active_icon->w,active_icon->h};    
    SDL_BlitSurface(background, &rect, screen, &rect); //Clear icon

    //Need to animate better
    SDL_BlitSurface(active_icon, NULL, screen, &rect);
    
    */
}

void menu_osd(SDL_Surface* screen)  {}

void menu_move(Direction dir) 
{
    int delta =  dir==PREV ? -1 : 1;
    
    if (number_of_submenuitem > 0) {
        if (dir == PREV) {
            menu_close_sub();
        } else {
            //sound_out( OUT );  
        }
        return;
    }
    
    menu_state_changed();
    
    int prev_menu_index = current_menu_index;
    current_menu_index = wrap(current_menu_index+ delta, 0, number_of_menu-1);
    if (get_tv_flag() == 1){
	    if (dir == PREV) {
		    current_menu_offset = -(menu_icons[current_menu_index]->w );
		    //scroll in 5 steps(frames)
		    current_menu_offset_step = menu_icons[current_menu_index]->w / 2;
	    } else {
		    current_menu_offset = menu_icons[prev_menu_index]->w ;
		    current_menu_offset_step = menu_icons[prev_menu_index]->w / 2;
	    }

    }else{
	    if (dir == PREV) {
		    current_menu_offset = -(menu_icons[current_menu_index]->w );
		    //scroll in 5 steps(frames)
		    current_menu_offset_step = menu_icons[current_menu_index]->w / 3;
	    } else {
		    current_menu_offset = menu_icons[prev_menu_index]->w ;
		    current_menu_offset_step = menu_icons[prev_menu_index]->w / 3;
	    }
    }
    sound_out( MENU_MOVE );
    current_menuitem_index = 0;
}

void menu_move_item(Direction dir ) 
{
    menu_state_changed();
    
    int delta = dir == PREV ? -1 : 1;
    int nosi = number_of_submenuitem;
    int nomi = number_of_menuitem[current_menu_index];
    int next_mi = current_menuitem_index + delta;
    int next_si = current_submenuitem_index + delta;
    
    if (!nosi) {
        int prev_menuitem_index = current_menuitem_index;
        current_menuitem_index = wrap(next_mi, 0, nomi-1);
        if (nomi > 1) { //Only animate if we have more than 1 menuitem
            if (dir == PREV) {
                current_menuitem_offset = -menuitem_icons[current_menu_index][current_menuitem_index]->h;
                current_menuitem_offset_step = menuitem_icons[current_menu_index][current_menuitem_index]->h / 3;
            } else {
                current_menuitem_offset = menuitem_icons[current_menu_index][prev_menuitem_index]->h;
                current_menuitem_offset_step = menuitem_icons[current_menu_index][prev_menuitem_index]->h / 3;
            }
        }
    }
    else {
        int prev_submenuitem_index = current_submenuitem_index;
        current_submenuitem_index = wrap(next_si, 0, nosi-1);
        if (nosi > 1) { //Only animate if we have more than 1 submenu item
            if (dir == PREV) {
                current_submenuitem_offset = -submenuitem_icons[current_submenuitem_index]->h;
                current_submenuitem_offset_step = submenuitem_icons[current_submenuitem_index]->h / 3;
            } else {
                current_submenuitem_offset = submenuitem_icons[prev_submenuitem_index]->h;
                current_submenuitem_offset_step = submenuitem_icons[prev_submenuitem_index]->h / 3;
            }
        }
    }
    sound_out( MENUITEM_MOVE );    
}

extern int get_tvdev_value();
static int tv_value;

int get_cur_select_index(char * str)
{
	if (strcasecmp(str,COMMAND_HANDLENOSELECT) == 0){
		return !handle_value;
	}else if (strcasecmp(str,COMMAND_TVCLOSESELECT) == 0){
		tv_value = get_tvdev_value();
		//printf("=============tv_value is %d============\n",tv_value);
		//printf("=============tv_flag is %d ============\n",get_tv_flag());
		if(tv_value == 0)
		return 1;
		else return !get_tv_flag();
	}else if (strcasecmp(str,COMMAND_GSENSORCLOSE) == 0){
		return !gsensor_open_flag;
	}else if (strcasecmp(str,COMMAND_RUSSELECT) == 0){
		int lang_value = get_sys_language();
		//printf("=========%s     %d     lang_value is  %d   \n==========",__FILE__,__LINE__,lang_value);
		return lang_value;
	}else if (strcasecmp(str,COMMAND_SOUND4SELECT) == 0){
		return get_sound_value();
	}else if (strcasecmp(str,COMMAND_TIME0SELECT) == 0){
		int bk_time = get_bright_time();
		switch (bk_time){
			case 0:  return 6;
			case 5:  return 0;
			case 10: return 1;
			case 15: return 2;
			case 20: return 3;
			case 30: return 4;
			case 60: return 5;
		}
		return 0;
	}else if (strcasecmp(str,COMMAND_BACKLIGHT5SELECT) == 0){
		return get_bright_value();
	}else if (strcasecmp(str,COMMAND_A320_ZOOM_IN_MODE) == 0){
	//	printf("a320_mode_flag is %d  \n",a320_mode_flag);
		return get_mode_state();
	}else
		return 0;
}
void menu_open_sub()
{
    menu_state_changed();
    int i;
    SDL_Color* color = get_theme_font_color();
    sound_out( DECIDE );  

    number_of_submenuitem = cfg_size(menu_item_config, "SubMenuItem");
    submenuitem_icons = new_array(SDL_Surface*, number_of_submenuitem);
    submenuitem_text  = new_array(SDL_Surface*, number_of_submenuitem);
    
    for (i=0;i<number_of_submenuitem;i++) {
        menu_subitem_config = cfg_getnsec(menu_item_config, "SubMenuItem", i);
        submenuitem_icons[i] = load_theme_image(cfg_getstr(menu_subitem_config, "Icon"));
        submenuitem_text[i]  = draw_text(cfg_getstr(menu_subitem_config, "Name"), menuitem_font, color);
    }    
    
    free_color(color);
    //current_submenuitem_index = 0;
    current_submenuitem_index = get_cur_select_index(cfg_getstr(menu_subitem_config, "Executable"));
}

void menu_close_sub()
{
    menu_state_changed();
    
    int i;

    sound_out( CANCEL );
    for (i=0;i<number_of_submenuitem;i++) {
        free_surface(submenuitem_icons[i]);
        free_surface(submenuitem_text[i]);
    }

    free_erase(submenuitem_icons);
    free_erase(submenuitem_text);
    
    number_of_submenuitem = 0;
}


MenuState menu_run_internal()
{
    char* executable = cfg_getstr(menu_active_item_config, "Executable");
    char* name       = cfg_getstr(menu_active_item_config, "Name");
    char* tmp;
    MenuState state = MAINMENU;
    int rc=0,i = 0;
	log_debug("executable = %s\n",executable);
	log_debug("command = %d\n",get_command(executable));
    switch (get_command(executable))
    {
        case THEMESELECT:
            rc = imageviewer_init_theme(name, executable, DMENU_THEMES);
            if (!rc) state = IMAGEVIEWER;
            break;
        case BACKGROUNDSELECT:
		            rc = imageviewer_init(name, executable, DMENU_BACKGROUNDS, NULL);
            if (!rc) state = IMAGEVIEWER;
            break;
        case COLORSELECT:
            tmp = theme_file(get_user_attr("Background"));
            rc = colorpicker_init(name, executable, NULL, get_theme_font_color_string(), tmp);
            if (!rc) state = COLORPICKER;
            free_erase(tmp);
            break;
		//alter add
#if 1

	    // language
	case CHSELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case ENSELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case JAPSELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case SPAINSELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case RUSSELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;

	    // backlight time 
	case TIME0SELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case TIME1SELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case TIME2SELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case TIME3SELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case TIME4SELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case TIME5SELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case TIME6SELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;

	    //sound
	case SOUND0SELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case SOUND1SELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case SOUND2SELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case SOUND3SELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case SOUND4SELECT:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	    //handle
	case HANDLESELECT:
	    handle_value = 1;
	    system(executable+1);
	    break;
	case HANDLENOSELECT:
	    handle_value = 0;
	    system(executable+1);
	    break;
	    //backlight
	case BACKLIGHT1SELECT:
	    brightness_set_nowritecfg(20);
	    system(executable+1);
	    SDL_Delay(50);
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case BACKLIGHT2SELECT:
	    brightness_set_nowritecfg(40);
	    system(executable+1);
	    SDL_Delay(50);
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case BACKLIGHT3SELECT:
	    brightness_set_nowritecfg(60);
	    system(executable+1);
	    SDL_Delay(50);
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case BACKLIGHT4SELECT:
	    brightness_set_nowritecfg(80);
	    system(executable+1);
	    SDL_Delay(50);
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case BACKLIGHT5SELECT:
	    brightness_set_nowritecfg(99);
	    system(executable+1);
	    SDL_Delay(50);
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	    //TV
	case TVOPENSELECT:
	    //audiosd_close();
	    dmenu_set_vol(0);
	    brightness_dim_tvopen();
	    system(executable+1);
	    break;
	case TVCLOSESELECT:
	    //audiosd_open();
	    dmenu_set_vol(get_cur_vol());
	    system(executable+1);
	    SDL_Delay(1000);
	    brightness_dim_tvclose();
	    break;
	    //udc
	case UDCOPENSELECT:
#if 0
	    if (get_udc_state() == 1){
		    udc_open_flag = 1;
		    draw_udc_waittext(udc_wait_textface);
		    system("/usr/bin/udc_connect.sh");
	    }else{
		    draw_udc_waittext(udc_tip_textface);
	    }
	    SDL_Delay(2000);
#endif
	    break;
	case UDCCLOSESELECT:
	    //draw_udc_waittext(udc_wait_textface);
	    //system(executable+1);
	    break;
	    //gsensor
	case GSENSOROPEN:
	    //gsensor_open_flag = 1;
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case GSENSORCLOSE:
	    //gsensor_open_flag = 0;
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	    //about a380
	case SYSCONFIG:
	    cfg_flag = 1;
	    //system(executable+1);
	    break;
	case A320_CLOSE_MODE:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case A320_ZOOM_OUT_MODE:
	//	printf("+++++++++++++++++++++++++++++++++++++++++++++++++\n");
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case A320_ZOOM_IN_MODE:
	    system(executable+1);
	    SDL_Delay(50);
	    quit();
	    add_crc_file(DMENU_CONF_FILE);
	    break;
	case UNLOCK_MENU:
#if GAMELOCK_ENABLED
	    unlock_flag = 1;
#endif
	    break;
#endif
	    //add end
    }

    return state;
}
int check_is_dir(const char * name)
{
	struct stat info;
	if (stat(name,&info) == -1){
		return 0;
	}
	if (S_ISDIR(info.st_mode)){
		return 1;
	}else{
		return 0;
	}
}
MenuState menu_run_item()
{
	char* executable = cfg_getstr(menu_active_item_config, "Executable");
	char* pic_dir = cfg_getstr(menu_active_item_config, "Icon");
	//char* tmp_char = cfg_getstr(menu_config,"Menu");
	//alterac  add  for get app cpu freq
	if (executable) {
		if (internal_command(executable)) {
			if (check_crc_file(DMENU_CONF_FILE) < 0){
				char tmp_char[256];
				memset(tmp_char,0,256);
				sprintf(tmp_char,"rm %s;cp %s %s",DMENU_CONF_FILE,DMENU_CONF_ROOT_FILE,DMENU_CONF_FILE);
				system(tmp_char);
				SDL_Delay(50);
				sync();
				//flush_block("/dev/mtdblock4");
				add_crc_file(DMENU_CONF_FILE);
			}

			return menu_run_internal();
		} 
		else {
			//alterac add  for set cpu  freq
			int app_freq = active_conf_int("Freq");
			int ret ;
			printf("app frea value = %d\n",app_freq);
			set_cpu_freq(app_freq);
			//end
		//	if (!strcasecmp(tmp_char,"setup")){
			//	draw_sys_note();
		//	}
			run_command(executable, NULL, cfg_getstr(menu_active_item_config, "WorkDir"));
		}
	} else {
		menu_open_sub();
	}

	return MAINMENU;
}

void save_unlock_flag()
{
	char tmp_str[64];
	memset(tmp_str,0,64);
	sprintf(tmp_str,"sed -i '1 c\Game_unlock = %d'  /usr/etc/dmenu/dmenu_lock.ini;sync",unlock_to_game);
	system(tmp_str);
	add_lock_crc_file(DMENU_LOCK_CONF_FILE);
	system("cp /usr/local/dmenu/remount/ /tmp/ -r");
	if(unlock_to_game)
		run_command("./remount_to_write_1.sh",NULL,"/tmp/remount/");
	else
		run_command("./remount_to_write_0.sh",NULL,"/tmp/remount/");
}

static int tick_step = 0;

static unsigned char*keystate;

MenuState menu_keypress(SDLKey key)
{
	MenuState state = MAINMENU;
	Direction dir = getKeyDir(key);

	if(cfg_flag && unlock_flag == 0)
	{
		keystate = SDL_GetKeyState(NULL);

		if(keystate[DINGOO_BUTTON_L]&&keystate[DINGOO_BUTTON_R]&&keystate[DINGOO_BUTTON_START])
		{
#if GAMELOCK_ENABLED
			unlock_flag = 1;
#endif
			tick_step = 0;
		}

		if(keystate[DINGOO_BUTTON_L]&&keystate[DINGOO_BUTTON_R]&&keystate[DINGOO_BUTTON_A])
		{
			system("cp /usr/local/version.text /mnt/memory/");
			sync();
		}
	}


    switch (key) {
		case DINGOO_BUTTON_X:
		case DINGOO_BUTTON_Y:
			if(unlock_flag)
			{
				tick_step++;
				if(tick_step > 12)
					tick_step=0;
				unlock_success = 0;
				break;
			}
			break;
		case DINGOO_BUTTON_SELECT:
			if(unlock_flag)
			{
				tick_step=0;
				unlock_success = 0;
				unlock_flag = 0;
				break;
			}
			break;
        case DINGOO_BUTTON_LEFT:
        case DINGOO_BUTTON_RIGHT:
			if(unlock_flag) 
			{
				tick_step++;
				if(tick_step > 12)
					tick_step=0;
				unlock_success = 0;
				break;
			}
			if (cfg_flag)  break;
            menu_move(dir);
            break;
        case DINGOO_BUTTON_UP:
        case DINGOO_BUTTON_DOWN:
			if(unlock_flag) 
			{
				tick_step++;
				if(tick_step > 12)
					tick_step=0;
				unlock_success = 0;
				break;
			}
			if (cfg_flag)  break;
            menu_move_item(dir);
            break;
        case DINGOO_BUTTON_B:
			if(unlock_flag)
			{
				printf("unlock is %d\n",unlock_success);
				tick_step++;
				if(tick_step > 12)
				{
					tick_step=0;
					break;
				}

				if(tick_step > 5)
				{
					unlock_success = 0;
					break;
				}

				if(unlock_success == 3)
				{
					tick_step = 0;
					unlock_success = 4;
					printf("%s %d unlock_to_game = %d\n", __func__, __LINE__, unlock_to_game);
					if(unlock_to_game)
					{
						unlock_to_game = 0;
					}
					else
					{
						unlock_to_game = 1;
					}
					save_unlock_flag();
					break;
				}

				if(unlock_success == 2)
					unlock_success = 3;

				if(unlock_success < 2)
					unlock_success = 0;
				break;
			}

            if (number_of_submenuitem > 0) menu_close_sub();
			if (cfg_flag)     cfg_flag = 0;
            break;
        case DINGOO_BUTTON_A:
			if(unlock_flag) 
			{
				tick_step++;
				if(tick_step>12)
				{
					tick_step=0;
					break;
				}

				if(tick_step > 5)
				{
					unlock_success = 0;
					break;
				}

				printf("unlock is %d\n",unlock_success);
				if(unlock_success > 1)
				{
					unlock_success = 0;
					break;
				}

				if(unlock_success == 1)
					unlock_success = 2;

				if(unlock_success == 0)
					unlock_success = 1;
				break;
			}
	    if (cfg_flag)  break;
	    menu_update_items();

	    if (menu_active_item_config == 0) break;
	    if (active_conf_bool("Selector") 
			    && !internal_command(active_conf_str("Executable"))) 
	    {
		    char* listdir = active_conf_str("SelectorDir");
		    //alterac add
		    char* format = active_conf_str("Selectformat");
		    int str_len = strlen(format);
		    memset(file_format,0,FORMAT_MAX);
		    memcpy(file_format,format,(str_len+1)>FORMAT_MAX ? FORMAT_MAX : (str_len+1));
		    //end
		    if (!listdir ) listdir = active_conf_str("WorkDir");
		    if (!filelist_init(
					    active_conf_str("Name"),    active_conf_str("Executable"),
					    active_conf_str("WorkDir"),listdir, 1))
		    {
			    old_state = state = FILELIST;
			    log_debug("a  old_state  = %d\n",old_state);
		    } // else we are not able to initialise the filelist display
	    } 
	    else {
		    old_state = 0;
		    state = menu_run_item();
	    }
	    break;
	default: break;
    }
    return state;

}

void get_lock_state_text_face(const char* temp_str,SDL_Surface* face)
{
	SDL_Color* tmp_color;
	tmp_color = get_theme_font_color();
	SDL_Rect tmp_offset;
	SDL_Surface* temp_text = NULL;
	temp_text = draw_text(temp_str,menu_font,tmp_color);

	SDL_BlitSurface(background,NULL,face,NULL);
	tmp_offset.x = (SCREEN_WIDTH - temp_text->w)/2;tmp_offset.y = (SCREEN_HEIGHT - temp_text->h)/2;
	SDL_BlitSurface(temp_text,NULL,face,&tmp_offset);

	SDL_FreeSurface(temp_text);
}

void get_code_text_face(const char* temp_str,SDL_Surface* face)
{
	SDL_Color* tmp_color;
	tmp_color = get_theme_font_color();
	SDL_Rect tmp_offset;
	SDL_Rect code_offset;
	SDL_Rect info_offset;
	SDL_Surface* back_button_text = NULL;
	SDL_Surface* temp_text = NULL;
	SDL_Surface* code_text = NULL;

	temp_text = draw_text(temp_str,menu_font,tmp_color);
	back_button_text = draw_text("Push Select to quit.",menu_font,tmp_color);

	info_offset.x = (SCREEN_WIDTH - back_button_text->w)/2;info_offset.y = (SCREEN_HEIGHT - back_button_text->h)/2 + 80;
	SDL_BlitSurface(background,NULL,face,NULL);
	SDL_BlitSurface(back_button_text,NULL,face,&info_offset);
	tmp_offset.x = (SCREEN_WIDTH - temp_text->w)/2;tmp_offset.y = (SCREEN_HEIGHT - temp_text->h)/2 - 20;
	code_text = draw_text(res_code_symbol[tick_step],menu_font,tmp_color);
	code_offset.x = (SCREEN_WIDTH - code_text->w)/2;code_offset.y = (SCREEN_HEIGHT - code_text->h)/2 + 10;
	SDL_BlitSurface(code_text,NULL,face,&code_offset);
	SDL_BlitSurface(temp_text,NULL,face,&tmp_offset);

	SDL_FreeSurface(temp_text);
	SDL_FreeSurface(code_text);
	SDL_FreeSurface(back_button_text);
}

void draw_unlock_view(SDL_Surface* face)
{
	int lang_value = 0;
	lang_value = get_sys_language();
	if(unlock_success==4)
	{
		if(unlock_to_game == 1)
		{
			unlock_flag = 0;
			unlock_success = 0;
			tick_step = 0;
			get_lock_state_text_face(res_unlock_ok[lang_value],face);
			SDL_Flip(face);
			SDL_Delay(2000);
		}
		else
		{
			unlock_flag = 0;
			unlock_success = 0;
			tick_step = 0;
			get_lock_state_text_face(res_lock_ok[lang_value],face);
			SDL_Flip(face);
			SDL_Delay(2000);
		}
	}
	else
	{
		printf("unlock_to_game is %d\n",unlock_to_game);
		if(unlock_to_game == 1)
		{
			get_code_text_face(res_lock_info[lang_value],face);
		}
		else
		{
			get_code_text_face(res_unlock_info[lang_value],face);
		}
	}
}

void draw_sysabout(SDL_Surface* face)
{
		int lang_value = 0;
		int  total_size = 0,avail_size = 0;
		char tmp_str[128];
		SDL_Surface* text_face = NULL;
		SDL_Color* tmp_color;
		tmp_color = get_theme_font_color();
		SDL_Rect tmp_offset; 
		lang_value = get_sys_language();
		total_size = sys_get_mm_men(0);
		avail_size = sys_get_mm_men(1);
		printf("lang_value = %d  total_size = %d avail_size = %d\n",lang_value,total_size,avail_size);
		SDL_BlitSurface(background,NULL,face,NULL);
		text_face = draw_text(res_about[lang_value],menu_font,tmp_color);
		tmp_offset.x = (SCREEN_WIDTH - text_face->w)/2;tmp_offset.y = 0;
		SDL_BlitSurface(text_face,NULL,face,&tmp_offset);
		SDL_FreeSurface(text_face);

		memset(tmp_str,0,128);
		strcpy(tmp_str,res_mode[lang_value]);
		strcat(tmp_str,": LN430");
		text_face = draw_text(tmp_str,menu_font,tmp_color);
		tmp_offset.x = 50;tmp_offset.y = 40;
		SDL_BlitSurface(text_face,NULL,face,&tmp_offset);
		SDL_FreeSurface(text_face);

		memset(tmp_str,0,128);
		strcpy(tmp_str,res_totalsize[lang_value]);
		text_face = draw_text(tmp_str,menu_font,tmp_color);
		tmp_offset.x = 50;tmp_offset.y = 40+text_face->h;
		SDL_BlitSurface(text_face,NULL,face,&tmp_offset);
		SDL_FreeSurface(text_face);

		memset(tmp_str,0,128);
#if 1
		if (total_size < 1024){
				sprintf(tmp_str,"%d  MB",total_size);
		}else{
				float size_total = ((float)total_size)/1024.00;
				sprintf(tmp_str,"%.2f  GB",size_total);
		}
#else
		sprintf(tmp_str,"%d  MB",total_size);
#endif
		text_face = draw_text(tmp_str,menu_font,tmp_color);
		tmp_offset.x = 50+150;tmp_offset.y = 40+text_face->h*2;
		SDL_BlitSurface(text_face,NULL,face,&tmp_offset);
		SDL_FreeSurface(text_face);

		memset(tmp_str,0,128);
		strcpy(tmp_str,res_availablesize[lang_value]);
		text_face = draw_text(tmp_str,menu_font,tmp_color);
		tmp_offset.x = 50;tmp_offset.y = 40+text_face->h*3+10;
		SDL_BlitSurface(text_face,NULL,face,&tmp_offset);
		SDL_FreeSurface(text_face);

		memset(tmp_str,0,128);
#if 1
		if (avail_size < 1024){
				sprintf(tmp_str,"%d  MB",avail_size);
		}else{
				float size_avail = ((float)avail_size)/1024.00;
				sprintf(tmp_str,"%.2f  GB",size_avail);
		}
#else
		sprintf(tmp_str,"%d  MB",avail_size);
#endif
		text_face = draw_text(tmp_str,menu_font,tmp_color);
		tmp_offset.x = 50+150;tmp_offset.y = 40+text_face->h*4+10;
		SDL_BlitSurface(text_face,NULL,face,&tmp_offset);
		SDL_FreeSurface(text_face);

		memset(tmp_str,0,128);
		//sprintf(tmp_str,"%s              V1.0001",res_version[lang_value]);
		extern int version_read_from_conf_flag;
		if(version_read_from_conf_flag)
			sprintf(tmp_str,"%s:                      %s",res_version[lang_value],get_theme_release());
		else
			sprintf(tmp_str,"%s:                      %s",res_version[lang_value],VERSION_GIT);
		text_face = draw_text(tmp_str,menu_font,tmp_color);
		tmp_offset.x = 50;tmp_offset.y = 40+text_face->h*5+20;
		SDL_BlitSurface(text_face,NULL,face,&tmp_offset);
		SDL_FreeSurface(text_face);

		memset(tmp_str,0,128);
		strcpy(tmp_str,"www.umidotech.com");
		text_face = draw_text(tmp_str,menu_font,tmp_color);
		tmp_offset.x = (SCREEN_WIDTH-text_face->w)/2;tmp_offset.y = 40+text_face->h*7+10;
		SDL_BlitSurface(text_face,NULL,face,&tmp_offset);
		SDL_FreeSurface(text_face);
    		free_color(tmp_color);
}

