
#include "p2p.h"
#include <unistd.h>
char dns[8][SSID_SZ] ;
static int msg_failed = 0;
static int p2p_mode_error = 0;

void p2p_nego_proc(struct p2p *p);
void p2p_client_mode_proc(struct p2p* p);
void p2p_go_mode_proc(struct p2p *p);
extern int p2p_mode;


extern int cur_list_index;
extern void p2p_draw_link_out();
extern void open_sdl_key();
extern void close_sdl_key();


#if P2P_SCAN_THREAD

void p2p_scan_dev(struct p2p *p);
#endif

int get_mode_error_flag()
{
	return p2p_mode_error;
}

void set_mode_error_flag(int value)
{
	p2p_mode_error = value;
}

int get_msg_link()
{
	return msg_failed;
}

void set_msg_link(int value)
{
	msg_failed = value;
}

unsigned int wps_pin_checksum(unsigned int pin)
{
	unsigned int accum = 0;
	while( pin )
	{
		accum += pin % 10;
		pin /= 10;
		accum += 3 * (pin % 10);
		pin /= 10;
	}
	return( accum % 10 );
}

char lower(char s)
{    
	if(('A' <= s) && (s <= 'Z'))
		return ( s = 'a' + (s - 'A') );
	return s;
}

void p2p_enable(struct p2p *p)
{
	if(p->enable == -1 )
	{
		if(p->wpa_open == 1){
			p->wpa_open = 0;
			system("killall wpa_supplicant");
#ifdef DHCP
			system("killall dhclient");
#endif			
		}
		if(p->ap_open ==1){
			p->ap_open = 0;
			system("killall hostapd");
#ifdef DHCP
			system("killall dhcpd");
#endif
		}

		memset( p->cmd, 0x00, CMD_SZ );
		sprintf( p->cmd, "iwpriv %s p2p_set enable=0", p->ifname);
		system( p->cmd );
		
		return;
	}
	
	p->p2p_get=0;
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_set enable=%d", p->ifname, p->enable);
	system( p->cmd );
	
	if( p->enable == P2P_ROLE_DISABLE )
	{
		p->have_p2p_dev = 0;
		p->wps_info = 0;
		p->pin = 12345670;

		if(p->res == 0)
		{
			pthread_cancel(p->pthread);
			p->res = 1;
		}

#if P2P_SCAN_THREAD
		if (p->res_scan == 0){
			pthread_cancel(p->pthread_scan);
			p->res_scan = 1;
		}
#endif

#if 0
		if(p->res_go == 0)
		{
			pthread_cancel(p->pthread_go);
			p->res_go = 1;
		}
#endif
				
		p->wpa_open = 0;
		system("killall wpa_supplicant");
#ifdef DHCP
		system("killall dhclient");
#endif
		p->ap_open = 0;
		system("killall hostapd");
#ifdef DHCP
		system("killall dhcpd");
#endif
		
	}
	else if( p->enable == P2P_ROLE_DEVICE )
	{
		p2p_setDN(p);
		p->res = 0;

#ifdef P2P_AUTO
		p->res = pthread_create(&p->pthread, NULL, &polling_status, (void *)p);
#endif
		
		if( p->res !=0 )
		{
#if DEBUG
			p->p2p_get=1;
			memset( p->print_line, 0x00, CMD_SZ );
			sprintf( p->print_line, "Thread creation failed" );
#endif
		}
		
		if(p->wpa_open == 1){
			p->wpa_open = 0;
			system("killall wpa_supplicant");
#ifdef DHCP
			system("killall dhclient");
#endif
		}
		if(p->ap_open ==1){
			p->ap_open = 0;
			system("killall hostapd");
#ifdef DHCP
			system("killall dhcpd");
#endif
		}
		
		//if (p2p_mode == 0)   //host go
		//	p->intent = 15;

		p2p_intent(p);
		
		p2p_set_opch(p, NULL, 0);
		usleep(50000);
		p2p_softap_ssid(p, NULL, 0);

#if P2P_SCAN_THREAD
		p->res_scan = 0;
		p->res_scan = pthread_create(&p->pthread_scan, NULL, &p2p_scan_dev, (void *)p);
#endif


		//p2p_scan( p );
	}
}

void p2p_scan(struct p2p *p)
{
	p->p2p_get=0;
	if( p->enable >= P2P_ROLE_DEVICE )
	{
		p->have_p2p_dev=1;
		memset( p->cmd, 0x00, CMD_SZ );
		sprintf( p->cmd, "iwlist %s scan > %s", p->ifname ,CONFIG_SCAN_PATH);
		system( p->cmd );
		system("sync");

		p2p_status(p, 0);
		
	}
	else
	{
		p->p2p_get=1;
		memset( p->print_line, 0x00, CMD_SZ );
		sprintf( p->print_line, "%s", p->scan_msg );
	}
}


#if 0
void scan_result(struct p2p *p)
{
	FILE *pf=NULL;
	
	pf = fopen( "./scan.txt", "r" );
	if ( pf )
	{
		int no_dev=0;
		char cms[30] = { 0x00 };
		char dns[SSID_SZ] = { 0x00 };
		char parse[100] = { 0x00 };
		
		p->count_line=0;
		while( (!feof( pf )) && (no_dev <= SCAN_POOL_NO)){
			memset( parse, 0x00, CMD_SZ );
			fgets( parse, CMD_SZ, pf );

			if(parse[0] == '\n' || parse[0] == '\0')
				break;
			if( strncmp(parse+10, "Scan completed :", 16) == 0 )
			{
				printf("* NO   DEVICE NAME                BSSID                 GO    CONFIG METHOD                        *\n");
				p->count_line++;
			}
			else if( strncmp(parse+20, "Address:", 8) == 0 )
			{
				struct scan *pscan_pool = &p->scan_pool[no_dev];
				memset( pscan_pool->addr, 0x00, CMD_SZ );
				strncpy( pscan_pool->addr, parse+29, 17);
			}
			else if( strncmp(parse+20, "ESSID:", 6) == 0 )
			{
				struct scan *pscan_pool = &p->scan_pool[no_dev];

				p2p_wps_cm(p, pscan_pool->addr, cms);
				p2p_device_name(p, pscan_pool->addr, dns);
				
				if( strncmp(parse+26, "\"DIRECT-\"", 9) == 0 )
				{
					printf("*[%02d]  %-25s  %s          %-38s*\n",no_dev+1, dns, pscan_pool->addr, cms);	
				}
				else
				{
					printf("*[%02d]  %-25s  %s      *   %-38s*\n",no_dev+1, dns, pscan_pool->addr, cms);	
					pscan_pool->go = 1;
				}
				p->count_line++;
				no_dev++;
				
			}
		}
		if( p->count_line < (SCAN_POOL_NO + 1) )
		{
			for(p->count_line; p->count_line < SCAN_POOL_NO+1; p->count_line++ )
				printf("*                                                                                                  *\n");
		}
		fclose( pf );
	}

}
#else
int scan_result(struct p2p *p)
{
	FILE *pf=NULL;
	int no_dev=0;
	int n_flag = 0;
	
	pf = fopen( CONFIG_SCAN_PATH, "r" );
	if ( pf )
	{
		char cms[30] = { 0x00 };
		char parse[100] = { 0x00 };
		char *str1 = NULL,* str2 = NULL;
		memset(dns,0,sizeof(dns));
		str2 = strrchr(p->dev_name,'-');

		while( (!feof( pf )) && (no_dev <= SCAN_POOL_NO)){
			memset( parse, 0x00, CMD_SZ );
			fgets( parse, CMD_SZ, pf );

			if(parse[0] == '\n' || parse[0] == '\0')
				break;
		
			if( strncmp(parse+20, "Address:", 8) == 0 )
			{
				if (no_dev >= 8){
					break;
				}
				struct scan *pscan_pool = &p->scan_pool[no_dev];
				memset( pscan_pool->addr, 0x00, CMD_SZ );
				strncpy( pscan_pool->addr, parse+29, 17);
			}
			else if( strncmp(parse+20, "ESSID:", 6) == 0 )
			{
				if (no_dev >= 8){
					break;
				}
				n_flag = 1;
				struct scan *pscan_pool = &p->scan_pool[no_dev];

				p2p_wps_cm(p, pscan_pool->addr, cms);
				p2p_device_name(p, pscan_pool->addr, dns[no_dev]);

				printf("\n   dns  =  %s   dev_name = %s\n",dns[no_dev],p->dev_name);
				str1 = strrchr(dns[no_dev],'-');
				
				if( strncmp(parse+26, "\"DIRECT-\"", 9) == 0 )
				{
				}
				else
				{
					pscan_pool->go = 1;
				}

				no_dev++;

				if (str1 != NULL && str2 != NULL){
					if (strcmp(str1,str2) == 0){
						no_dev --;
					}else{
					}
				}else{
				}


			}
		}
		if (n_flag == 1 && no_dev == 0){
			p2p_mode_error = 1;
		}
		fclose( pf );
	}
	return no_dev;

}

#endif

#if P2P_SCAN_THREAD
static unsigned int scan_count = 0;
void p2p_scan_dev(struct p2p *p)
{
	while(p->res_scan == 0 && scan_count == 0){
		p2p_scan(p);
		scan_count = scan_result(p);
		usleep(200*1000);
	}
}

unsigned int get_dev_num()
{
	return scan_count;
}

void set_dev_num(unsigned int val)
{
	scan_count = val;
}

#else
int p2p_scan_dev(struct p2p *p)
{
	int scan_count;
	p2p_scan(p);
	scan_count = scan_result(p);
	return scan_count;
}

#endif

void p2p_setDN(struct p2p *p)
{

	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_set setDN=%s", p->ifname, p->dev_name);
	system( p->cmd );
}

void p2p_intent(struct p2p *p)
{
	p->p2p_get=0;
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_set intent=%d", p->ifname, p->intent);
	system( p->cmd );
}

void p2p_wpsinfo(struct p2p *p)
{
	p->p2p_get=0;
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_set got_wpsinfo=%d", p->ifname, p->wps_info);
	system( p->cmd );
}

void p2p_pincode(struct p2p *p, char *ins_no, char *ins_no_again)
{
	int pin_check=0;
	p->p2p_get=0;
	ui_screen(p);
	printf("%s", ins_no);
	scanf("%d",&pin_check);
	while( wps_pin_checksum(pin_check) != 0 )
	{
		ui_screen(p);
		printf("%s", ins_no_again);	
		scanf("%d",&pin_check);
	}
	p->pin = pin_check;
}

int get_cur_p2p_device()
{
	return cur_list_index;
}

void p2p_devaddr(struct p2p *p)
{
	int c;
	struct scan *pscan_pool;

	p->p2p_get=0;
	
	c = get_cur_p2p_device();
	pscan_pool = &p->scan_pool[c];
	strncpy(p->peer_devaddr, pscan_pool->addr, 17);

	if( pscan_pool->go == 1)
		p->connect_go = 1;

}

void p2p_role(struct p2p *p, int flag)
{
	FILE *pf=NULL;
			
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_get role > %s", p->ifname,CONFIG_STATUS_PATH);
	system( p->cmd );
	system("sync");

	pf = fopen( CONFIG_STATUS_PATH, "r" );
	if ( pf )
	{
		while( !feof( pf ) ){
			memset( p->parse, 0x00, CMD_SZ );
			fgets( p->parse, CMD_SZ, pf );
			if( strncmp( p->parse, "Role", 4) == 0 )
			{
				p->role = atoi( &p->parse[ 5 ] );
				if(flag==1){
#if DEBUG
					p->p2p_get=1;
					sprintf( p->print_line, "Role=%s", naming_role(p->role));
#endif
				}
				break;
			}	
		}
		fclose( pf );
	}
}

void p2p_status(struct p2p *p, int flag)
{
	FILE *pf=NULL;
	
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_get status > %s", p->ifname,CONFIG_STATUS_PATH);
	system( p->cmd );
	system("sync");

	pf = fopen( CONFIG_STATUS_PATH, "r" );
	if ( pf )
	{
		while( !feof( pf ) ){
			memset( p->parse, 0x00, CMD_SZ );
			fgets( p->parse, CMD_SZ, pf );
			if( strncmp( p->parse, "Status", 6) == 0 )
			{
				p->status = atoi( &p->parse[ 7 ] );		
				if(flag==1){
#if DEBUG
					p->p2p_get=1;
					sprintf( p->print_line, "Status=%s", naming_status(p->status));
#endif
				}
				break;
			}	
		}
		fclose( pf );
	}
}

void p2p_prov_disc_no_addr(struct p2p *p, char *msg)
{
#if DEBUG
	p->p2p_get=1;
	memset( p->print_line, 0x00, CMD_SZ );
	sprintf( p->print_line, "%s", msg);
#endif
}

void get_p2p_cur_status(struct p2p *p)
{
	p2p_status( p, 1 );
	p->p2p_get=1;
	ui_screen(p);
}


#ifdef P2P_AUTO
void p2p_prov_disc(struct p2p *p, char *msg, char *dis_msg, char *label_msg)
{
	int wps_cm, retry_count=0;
	char prov[100] = { 0x00 };
	
	printf("%s", msg);
	wps_cm = 0;
//	int count =0 ;
	int error = 0;

	/* important case ,don't change it!*/

#if 0

	while(count < 10){
		get_p2p_cur_status(p);
		if (p->status == P2P_STATE_RX_PROVISION_DIS_REQ || p->status == P2P_STATE_TX_PROVISION_DIS_REQ){
			error ++;
			printf("\n ------------------ p2p status is wrong !-------------\n");
		}
		count ++;
		usleep(100*1000);
	}
	if (error >= 6){
		msg_failed = 1;
		p->enable = -1;
		return ;
	}
#endif

	/* end */

#if P2P_SCAN_THREAD
	if (p->res_scan == 0){
		p->res_scan = 1;
		pthread_cancel(p->pthread_scan);
	}
#endif

	if(p->res == 0)
	{
		pthread_cancel(p->pthread);
		p->res = 1;
	}
	usleep(100*1000);

	memset( p->cmd, 0x00, CMD_SZ );	
	if( wps_cm == 0 )
		sprintf( p->cmd, "iwpriv %s p2p_set prov_disc=%s_display", p->ifname, p->peer_devaddr);
	else if( wps_cm == 1 )
		sprintf( p->cmd, "iwpriv %s p2p_set prov_disc=%s_keypad", p->ifname, p->peer_devaddr);
	else if( wps_cm == 2 )
		sprintf( p->cmd, "iwpriv %s p2p_set prov_disc=%s_pbc", p->ifname, p->peer_devaddr);
	else if( wps_cm == 3 )
		sprintf( p->cmd, "iwpriv %s p2p_set prov_disc=%s_label", p->ifname, p->peer_devaddr);	
	system( p->cmd );
	strcpy( prov, p->cmd );

	usleep(1000000);
	p2p_status( p, 0 );
	error = 0;
	
	while(p->status != P2P_STATE_RX_PROVISION_DIS_RSP && retry_count < MAX_PROV_RETRY)
	{
		usleep( PROV_WAIT_TIME );
		retry_count++;
		get_p2p_cur_status(p);

		if( (retry_count % PROV_RETRY_INTERVAL) == 0){

			system( prov );
		}
	}

	if( p->status == P2P_STATE_RX_PROVISION_DIS_RSP )
	{
		p->wps_info = 1;

		ui_screen(p);
		p->pin = 12345670;

		p2p_wpsinfo(p);	

		p2p_nego_proc(p);

	}
	else
	{
		p2p_draw_link_out();
		//log_debug("\n medive  0000000000000000!\n");
		//printf("\n medive  0000000000000000!\n");
		msg_failed = 1;
		p->enable = -1;
#ifndef P2P_AUTO
		p->res = 0;
		p->res = pthread_create(&p->pthread,NULL,&polling_status,(void*)p);
#endif
	}

}
#else

// This mode is without the following procedures:
// 1.set config method
// 2.start group negotiation
// 3.start wpa_supplicant or hostapd
void p2p_prov_disc(struct p2p *p, char *msg, char *dis_msg, char *label_msg)
{
	int wps_cm;
	p->p2p_get=0;
	ui_screen(p);
	printf("%s", msg);
	scanf("%d",&wps_cm);
	memset( p->cmd, 0x00, CMD_SZ );

	
	if( wps_cm == 0 )
		sprintf( p->cmd, "iwpriv %s p2p_set prov_disc=%s_display", p->ifname, p->peer_devaddr);
	else if( wps_cm == 1 )
		sprintf( p->cmd, "iwpriv %s p2p_set prov_disc=%s_keypad", p->ifname, p->peer_devaddr);
	else if( wps_cm == 2 )
		sprintf( p->cmd, "iwpriv %s p2p_set prov_disc=%s_pbc", p->ifname, p->peer_devaddr);
	else if( wps_cm == 3 )
		sprintf( p->cmd, "iwpriv %s p2p_set prov_disc=%s_label", p->ifname, p->peer_devaddr);	
	system( p->cmd );

}
#endif


void p2p_nego_proc(struct p2p *p)
{

	int retry_count = 0, success = 0;

#if DEBUG
	p->p2p_get=1;
	memset( p->print_line, 0x00, CMD_SZ );
	strcpy( p->print_line, p->nego_msg);
	ui_screen(p);
#endif


	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_set nego=%s ", p->ifname, p->peer_devaddr);
	system( p->cmd );

	usleep( PRE_NEGO_INTERVAL );

	open_sdl_key();

	SDLKey key;
	SDL_Event event;
	SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY,SDL_DEFAULT_REPEAT_INTERVAL);//set delay to 0 disables  key repeat
	while(p->status != P2P_STATE_GONEGO_OK && retry_count < MAX_NEGO_RETRY){
		p2p_status(p, 0);
		p2p_role(p, 0);

		if( p->status != P2P_STATE_GONEGO_OK ){

			if( p->role == P2P_ROLE_CLIENT || p->role == P2P_ROLE_GO )
				break;

			if( retry_count > 0)
			{
				int check_status = 0;

				while(check_status < 5 && p->status != P2P_STATE_GONEGO_OK )
				{
					get_p2p_cur_status(p);
					if( check_status == 0 )
						ui_screen(p);

					if( p->status == P2P_STATE_GONEGO_OK )
					{
						success = 1;
						break;
					}

					usleep(400000);
					check_status++;
				}

			}

			if( success ==0 ){	//need to re-fine

				memset( p->cmd, 0x00, CMD_SZ );
				sprintf( p->cmd, "iwpriv %s p2p_set nego=%s ", p->ifname, p->peer_devaddr);
				system( p->cmd );

				usleep(100000);
				retry_count++;
			}
		}
		else
		{
#if DEBUG
			p->p2p_get = 1;
			memset( p->print_line, 0x00, CMD_SZ );
			sprintf( p->print_line, "%s", p->ok_msg );
#endif
			p2p_ifaddr(p);
			ui_screen(p);
			break;
		}
	if (SDL_PollEvent(&event)){
				switch (event.type){
					case SDL_QUIT: 
						retry_count = MAX_NEGO_RETRY;
						break;
					case SDL_KEYDOWN:
								key = event.key.keysym.sym;
								switch(key){
									case DINGOO_A:
										break;
									case DINGOO_B:
										retry_count = MAX_NEGO_RETRY;
										msg_failed = 1;
										p->enable = -1;
										break;
									default : break;
								}
								break;
						case SDL_KEYUP:
								break;

				}
	}



	}

	close_sdl_key();

	if( p->status == P2P_STATE_GONEGO_OK || p->role == P2P_ROLE_CLIENT || p->role == P2P_ROLE_GO )
	{
		p2p_role(p ,0);
		
		if( p->role == P2P_ROLE_CLIENT )
		{
			p2p_client_mode_proc(p);
			if (msg_failed == 1 && p->enable == -1){
			}
		}
		else if( p->role == P2P_ROLE_GO )
		{
			p2p_go_mode_proc(p);
			if (msg_failed == 1 && p->enable == -1){
			}
		}
	}
	else
	{

		p2p_draw_link_out();
		//log_debug("\n medive  000ssssssssssss000000000000!\n");
	//	printf("\n medive  000ssssssssssss000000000000!\n");
		msg_failed = 1;
		p->enable = -1;

#ifndef P2P_AUTO
		p->res = 0;
		p->res = pthread_create(&p->pthread,NULL,&polling_status,(void*)p);
#endif
		
	}

}


//After negotiation success, get peer device's interface address.
void p2p_ifaddr(struct p2p *p)
{
	FILE *pf=NULL;
	char addr_12[12] = { 0x00 };
	int i;
	
	/* peer_ifaddr */
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_get peer_ifa > %s", p->ifname,CONFIG_STATUS_PATH);
	system( p->cmd );
	system("sync");
#if 1
	pf = fopen( CONFIG_STATUS_PATH, "r" );
	if ( pf )
	{
		memset( p->parse, 0x00, CMD_SZ );
		fgets( p->parse, CMD_SZ, pf );
		fgets( p->parse, CMD_SZ, pf );
		strncpy(addr_12, p->parse, 12 );

		for(i=0; i<6; i++)
		{
			p->peer_ifaddr[3*i] = addr_12[2*i];
			p->peer_ifaddr[3*i+1] = addr_12[2*i+1];
			if(i==5)
				p->peer_ifaddr[3*i+2] = '\0';
			else
				p->peer_ifaddr[3*i+2] = ':';
		}

		fclose( pf );
	}
#endif

	pf = fopen( CONFIG_STATUS_PATH, "r" );
	if ( pf )
	{
		while( !feof( pf ) ){
			memset( p->parse, 0x00, CMD_SZ );
			fgets( p->parse, CMD_SZ, pf );
			if( strncmp( p->parse, "MAC", 3) == 0 )
			{
				strncpy( p->peer_ifaddr, p->parse+4, 17 );
				break;
			}	
		}
		fclose( pf );
	}

	
}

void p2p_client_mode_proc(struct p2p* p)
{
	FILE *pf = NULL;
	int count = 0, ret = 0;

	int key_flag = 0;

	if(p->wpa_open==1)
		return;
	else
		p->wpa_open = 1;

#if 0
	get_p2p_cur_status(p);
	if (p->status == P2P_STATE_RX_PROVISION_DIS_REQ || p->status == P2P_STATE_TX_PROVISION_DIS_REQ){
		printf("\n ------------------ client mode  p2p status is wrong !-------------\n");
		msg_failed = 1;
		p->enable = -1;
		return ;
	}
#endif

	p2p_ifaddr(p);
	
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "%s/wpa_supplicant -i %s -c %s -B ",p->wpa_path, p->ifname, p->wpa_conf);
	//sprintf( p->cmd, "%s/wpa_supplicant -i %s -c %s -B & ",p->wpa_path, p->ifname, p->wpa_conf);
	system( p->cmd );

#if DEBUG
	p->p2p_get=1;
	memset( p->print_line, 0x00, CMD_SZ );
	strcpy( p->print_line, "Start wpa_supplicant");
	ui_screen(p);
#endif

	open_sdl_key();

	usleep( SUPPLICANT_INIT_TIME );
	SDLKey key;
	SDL_Event event;
	SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY,SDL_DEFAULT_REPEAT_INTERVAL);//set delay to 0 disables  key repeat
	while(ret == 0){
		if (SDL_PollEvent(&event)){
			switch (event.type){
				case SDL_QUIT: 
					key_flag = 1;
					ret = 1;
					break;
				case SDL_KEYDOWN:
					key = event.key.keysym.sym;
					switch(key){
						case DINGOO_A:
							break;
						case DINGOO_B:
							close_sdl_key();
							key_flag = 1;
							ret = 1;
							break;
						default : break;
					}
					break;
				case SDL_KEYUP:
					break;

			}
		}
		if(p->wps_info==1 || p->wps_info==2)
		{
			memset( p->cmd, 0x00, CMD_SZ );

			if(p->connect_go == 1)
				sprintf( p->cmd, "%s/wpa_cli wps_pin %s %d > %s", p->wpa_path, p->peer_devaddr, p->pin,CONFIG_SUPP_PATH);
			else
				sprintf( p->cmd, "%s/wpa_cli wps_pin %s %d > %s", p->wpa_path, p->peer_ifaddr, p->pin,CONFIG_SUPP_PATH);


			system( p->cmd );



			pf = fopen( CONFIG_SUPP_PATH, "r" );	
			if ( pf )
			{
				while( !feof( pf ) ){
					memset(p->parse, 0x00, CMD_SZ);
					fgets(p->parse, CMD_SZ, pf);
					if(strncmp(p->parse, "Selected", 8) == 0)
					{
						ret = 1;
						p->wpsing = 1;
					}
				}

				fclose( pf );
			}

			if( ret == 0 )
				//usleep( SUPPLICANT_INIT_TIME );
				usleep( 100000 );

		}
		system("sync");
	}

	usleep( SUPPLICANT_INTERVAL );

	p->enable= -1 ;
	msg_failed = 1;

	if (key_flag == 1){
		return;
	}


	while( count < WPS_RETRY )		//query status
	{
		if (SDL_PollEvent(&event)){
			switch (event.type){
				case SDL_QUIT: 
					count = WPS_RETRY;
					break;
				case SDL_KEYDOWN:
					key = event.key.keysym.sym;
					switch(key){
						case DINGOO_A:
							break;
						case DINGOO_B:
							close_sdl_key();
							count = WPS_RETRY;
							p2p_draw_link_out();
							break;
						default : break;
					}
					break;
				case SDL_KEYUP:
					break;

			}
		}

		memset( p->cmd, 0x00, CMD_SZ );
		sprintf( p->cmd, "%s/wpa_cli status > %s", p->wpa_path,CONFIG_SUPP_PATH);
		system( p->cmd );


		pf = fopen( CONFIG_SUPP_PATH, "r" );
		if ( pf )
		{
			while( !feof( pf ) ){
				memset( p->parse, 0x00, CMD_SZ );
				fgets( p->parse, CMD_SZ, pf );
				if( strncmp( p->parse, "wpa_state=", 10) == 0 )
				{
//					int i;
					if( strncmp( p->parse, "wpa_state=COMPLETED", 19) == 0 ){
						//printf("\n medive printf wpa_state ok !\n");
						count = WPS_RETRY;
						p->wpsing=0;
#ifdef DHCP
						memset( p->cmd, 0x00, CMD_SZ );
						sprintf( p->cmd, "dhclient %s", p->ifname);
						system( p->cmd );
#else
						p->enable= 1;
						msg_failed = 0;
						memset( p->cmd, 0x00, CMD_SZ );
						if (p2p_mode == 1)
							sprintf( p->cmd, "ifconfig %s 192.168.1.2", p->ifname);
						else  
							sprintf( p->cmd, "ifconfig %s 192.168.1.1", p->ifname);
						system( p->cmd );
#endif //DHCP
					}


#if DEBUG
					p->p2p_get=1;
					memset(p->print_line, 0x00, CMD_SZ);
					for(i=0; i<CMD_SZ; i++){
						if(p->parse[i] == '\n'){
							p->parse[i] = ' ';
						}
					
					}
					sprintf(p->print_line, "%s", p->parse);
					ui_screen(p);
#endif
					
					break;
				}	
			}

			fclose( pf );
		}
		
		count++;
		//usleep( SUPPLICANT_INTERVAL );
		system("sync");
		usleep( 300*1000 );
	}



}

void p2p_go_mode_proc(struct p2p *p)
{
	FILE *pf = NULL;
	int count = 0, ret = 0, i = -1;
	char addr_lower[18];
	int key_flag = 0;

	p2p_ifaddr(p);

#if DEBUG
	p->p2p_get=1;
	memset( p->print_line, 0x00, CMD_SZ );
	strcpy( p->print_line, "Start hostapd");
	ui_screen(p);
#endif

#if 0
	get_p2p_cur_status(p);
	if (p->status == P2P_STATE_RX_PROVISION_DIS_REQ || p->status == P2P_STATE_TX_PROVISION_DIS_REQ){
		printf("\n ------------------ go mode  p2p status is wrong !-------------\n");
		msg_failed = 1;
		p->enable = -1;
		return ;
	}
#endif


	if(p->ap_open != 1)
	{
		memset( p->cmd, 0x00, CMD_SZ );
		//sprintf( p->cmd, "%s/hostapd -B %s > %s",p->ap_path, p->ap_conf,CONFIG_TEMP_PATH);
		//sprintf( p->cmd, "%s/hostapd -B %s > %s &",p->ap_path, p->ap_conf,CONFIG_TEMP_PATH);
		sprintf( p->cmd, "%s/hostapd -B %s",p->ap_path, p->ap_conf);
		system( p->cmd );

		usleep( HOSTAPD_INIT_TIME );
	}

	open_sdl_key();
	SDLKey key;
	SDL_Event event;
	SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY,SDL_DEFAULT_REPEAT_INTERVAL);//set delay to 0 disables  key repeat
	while(ret == 0){
		if (SDL_PollEvent(&event)){
				switch (event.type){
						case SDL_QUIT: 
								ret = 1;
								key_flag = 1;
								break;
						case SDL_KEYDOWN:
								key = event.key.keysym.sym;
								switch(key){
									case DINGOO_A:
										break;
									case DINGOO_B:
										close_sdl_key();
										ret = 1;
										key_flag = 1;
										break;
									default : break;
								}
								break;
						case SDL_KEYUP:
								break;

				}
		}
		if(p->wps_info==1 || p->wps_info==2)
		{
			memset( p->cmd, 0x00, CMD_SZ );
			sprintf( p->cmd, "%s/hostapd_cli wps_pin any %d > %s", p->ap_path, p->pin,CONFIG_SUPP_PATH);
			system( p->cmd );


			pf = fopen( CONFIG_SUPP_PATH, "r" );	
			if ( pf )
			{
				while( !feof( pf ) ){
					memset(p->parse, 0x00, CMD_SZ);
					fgets(p->parse, CMD_SZ, pf);
					if(strncmp(p->parse, "", 2) == 0)
					{
						ret = 1;
						p->wpsing = 1;
					}
				}

				fclose( pf );
			}

			if( ret == 0 )
				//usleep( HOSTAPD_INIT_TIME );
				usleep( 100000 );
		}
		system("sync");
	}

	usleep( HOSTAPD_INTERVAL );


	p->enable= -1;
	msg_failed = 1;


	if (key_flag == 1){
		if(p->ap_open != 1)
			p->ap_open = 1;
		return;
	}
	
	while( count < WPS_RETRY )		//query status
	{
		if (SDL_PollEvent(&event)){
			switch (event.type){
				case SDL_QUIT: 
					count = WPS_RETRY;
					break;
				case SDL_KEYDOWN:
					key = event.key.keysym.sym;
					switch(key){
						case DINGOO_A:
							break;
						case DINGOO_B:
							close_sdl_key();
							count = WPS_RETRY;
							p2p_draw_link_out();
							break;
						default : break;
					}
					break;
				case SDL_KEYUP:
					break;

			}
		}


		memset( p->cmd, 0x00, CMD_SZ );
		//sprintf( p->cmd, "%s/hostapd_cli all_sta > supp_status.txt", p->ap_path, p->peer_ifaddr);
		sprintf( p->cmd, "%s/hostapd_cli all_sta  > %s", p->ap_path,CONFIG_SUPP_PATH);
		system( p->cmd );


		pf = fopen( CONFIG_SUPP_PATH, "r" );
		if ( pf )
		{
			for(i=0;i<17;i++)
			{
				if( p->ap_open != 1 )
					addr_lower[i] = lower(p->peer_ifaddr[i]);
				else
					addr_lower[i] = lower(p->peer_devaddr[i]);
			}
			addr_lower[17]='\0';

			while( !feof( pf ) ){
				memset( p->parse, 0x00, CMD_SZ );
				fgets( p->parse, CMD_SZ, pf );
				if( strncmp( p->parse, "dot11RSNAStatsSTAAddress=", 25) == 0 )
				{
					if( strncmp( p->parse+25, addr_lower, 17) == 0 )
					{

						//printf("\n medive printf host completed !\n");
						//usleep(3000*1000);
						count = WPS_RETRY;
						p->wpsing = 0;

						p->p2p_get=1;
						memset(p->print_line, 0x00, CMD_SZ);
						for(i=0; i<CMD_SZ; i++){
							if(p->parse[i] == '\n'){
								p->parse[i] = ' ';
							}
						}		
						sprintf(p->print_line, "%s", p->parse);
						ui_screen(p);
#ifdef DHCP
						memset( p->cmd, 0x00, CMD_SZ );
						sprintf( p->cmd, "ifconfig %s 192.168.1.1", p->ifname);
						system( p->cmd );

						usleep(50000);

						system( "/etc/rc.d/init.d/dhcpd start" );
						system( "clear" );
#else
						p->enable= 1;
						msg_failed = 0;
						memset( p->cmd, 0x00, CMD_SZ );
						if (p2p_mode == 0)
							sprintf( p->cmd, "ifconfig %s 192.168.1.1", p->ifname);
						else
							sprintf( p->cmd, "ifconfig %s 192.168.1.2", p->ifname);
						system( p->cmd );
#endif //DHCP

						//After starting hostapd and doing WPS connection successful,
						//We create a thread to query driver if some other p2p devices connected.
						p2p_status(p, 0);
						usleep(50000);


						break;
					}
				}
			}

			fclose( pf );
		}

		if( count == WPS_RETRY)
			break;

		count++;
		//usleep( HOSTAPD_INTERVAL );
		usleep( 300*1000 );

#if DEBUG
		p->p2p_get=1;
		memset( p->print_line, 0x00, CMD_SZ );
		sprintf( p->print_line, "hostapd open, count:%d", count);
		ui_screen(p);
#endif

		system("sync");
	}
	if(p->ap_open != 1)
		p->ap_open = 1;


}

void p2p_get_hostapd_conf(struct p2p *p)
{
	FILE *pf = NULL;
	
	pf = fopen( p->ap_conf, "r" );	
	if ( pf )
	{
		while( !feof( pf ) ){
			memset(p->parse, 0x00, CMD_SZ);
			fgets(p->parse, CMD_SZ, pf);
			if(strncmp(p->parse, "ssid=", 5) == 0)
			{
				strcpy( p->apd_ssid, p->parse+5 );
			}
			else if(strncmp(p->parse, "channel=", 8) == 0)
			{
				p->op_ch = atoi( p->parse+8 );
			}
			else if(strncmp(p->parse, "device_name=", 12) == 0)
			{
#if 0
				int i;
				p->dev_name[0] = '"';
				strncpy( p->dev_name+1, p->parse+12, 32 );
				for(i=31; i>0; i--)
				{
					if(p->dev_name[i] == '\n')
					{
						p->dev_name[i]='"';
						p->dev_name[i+1]=' ';
						break;
					}
				}
#else
				int i;
				strncpy( p->dev_name, p->parse+12, 31);
				for(i=DEVNAME_MAX_NUM; i>0; i--)
				{
					if(p->dev_name[i] == '\n')
					{
						p->dev_name[i]='\0';
						break;
					}
				}
				if (i == 0){
					p->dev_name[DEVNAME_MAX_NUM] = '\0';
				}

				if (p2p_mode == 0){
					strcat(p->dev_name,"-server");
				}else{
					strcat(p->dev_name,"-client");
				}

#endif

			}
		}

		fclose( pf );
	}
	
}

void p2p_set_opch(struct p2p *p, char *msg, int print)
{
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_set op_ch=%d", p->ifname, p->op_ch);
	system( p->cmd );
}

void p2p_softap_ssid(struct p2p *p, char *msg, int print)
{
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_set ssid=%s ", p->ifname, p->apd_ssid);
	system( p->cmd );
}

void p2p_listen_ch(struct p2p *p, char *msg)
{
	ui_screen(p);
	printf("%s", msg);
	scanf("%d",&p->listen_ch);
	
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_set listen_ch=%d ", p->ifname, p->listen_ch);
	system( p->cmd );
}

//When receive provision discovery request,
//it can show which device address that are connected.
void p2p_peer_devaddr(struct p2p *p, char *peer_devaddr)
{
	FILE *pf = NULL;
	char addr_12[12] = { 0x00 };
	int i;
	
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_get peer_deva > %s", p->ifname,CONFIG_PEER_PATH);
	system( p->cmd );
	system("sync");
	
	pf = fopen( CONFIG_PEER_PATH, "r" );
	if ( pf )
	{
		memset( p->parse, 0x00, CMD_SZ );
		fgets( p->parse, CMD_SZ, pf );
		fgets( p->parse, CMD_SZ, pf );
		strncpy(addr_12, p->parse, 12 );

		for(i=0; i<6; i++)
		{
			p->peer_devaddr[3*i] = addr_12[2*i];
			p->peer_devaddr[3*i+1] = addr_12[2*i+1];

			if(i==5)
				p->peer_devaddr[3*i+2] = '\0';
			else
				p->peer_devaddr[3*i+2] = ':';
		}

		fclose( pf );

	}
	
}

//When receive provision discovery request,
//it can show which config method that want to be as WPS connection.
void p2p_peer_req_cm(struct p2p *p, char *peer_req_cm)
{
	FILE *pf = NULL;
	
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_get req_cm > %s", p->ifname,CONFIG_PEER_PATH);
	system( p->cmd );
	system("sync");
	
	pf = fopen(CONFIG_PEER_PATH, "r" );
	if ( pf )
	{
		while( !feof( pf ) ){
			memset( p->parse, 0x00, CMD_SZ );
			fgets( p->parse, CMD_SZ, pf );
			if( strncmp( p->parse, "CM", 2) == 0 )
			{
				strncpy( peer_req_cm, p->parse+3, 3 );
				break;
			}	
		}
		fclose( pf );
	}
	
}

//When be regotiated passsively and successfully,
//it will show peer device's peer device address and request config method
void p2p_peer_info(struct p2p *p, char *peer_devaddr, char *peer_req_cm)
{
#if DEBUG
	p->p2p_get=1;

	memset( p->print_line, 0x00, CMD_SZ );
	sprintf( p->print_line, "Peer address:%s, req_cm: %s ", peer_devaddr, peer_req_cm);
#endif

}

//After scan, it will get other devices' supported config methods.
void p2p_wps_cm(struct p2p *p, char *scan_addr, char *cms)
{
	FILE *pf = NULL;
	int cm=0, i=0;
	char parse[100] = {0x00};
	memset( cms, 0x00, 30 );

	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_get2 wpsCM=%s > %s", p->ifname, scan_addr,CONFIG_CM_PATH);	
	system( p->cmd );	
	system( "sync");	
		
	pf = fopen( CONFIG_CM_PATH, "r" );
	if ( pf )
	{
		while( !feof( pf ) ){
			memset( parse, 0x00, CMD_SZ );
			fgets( parse, CMD_SZ, pf );
			if( strncmp( parse, "M=", 2 ) == 0 )
			{
				cm = atoi( &parse[ 2 ] );
				
				if((cm & WPS_CONFIG_METHOD_LABEL) == WPS_CONFIG_METHOD_LABEL){
					strncpy( cms+i, " LAB", 4 );
					i=i+4;
				}
				if((cm & WPS_CONFIG_METHOD_DISPLAY) == WPS_CONFIG_METHOD_DISPLAY){
					if((cm & WPS_CONFIG_METHOD_VDISPLAY) == WPS_CONFIG_METHOD_VDISPLAY){
						strncpy( cms+i, " VDIS", 5 );
						i=i+5;
					}else if((cm & WPS_CONFIG_METHOD_PDISPLAY) == WPS_CONFIG_METHOD_PDISPLAY){
						strncpy( cms+i, " PDIS", 5 );
						i=i+5;
					}else{
						strncpy( cms+i, " DIS", 4 );
						i=i+4;
					}
				}
				if((cm & WPS_CONFIG_METHOD_E_NFC) == WPS_CONFIG_METHOD_E_NFC){
					strncpy( cms+i, " ENFC", 5 );
					i=i+5;
				}
				if((cm & WPS_CONFIG_METHOD_I_NFC) == WPS_CONFIG_METHOD_I_NFC){
					strncpy( cms+i, " INFC", 5 );
					i=i+5;
				}
				if((cm & WPS_CONFIG_METHOD_NFC) == WPS_CONFIG_METHOD_NFC){
					strncpy( cms+i, " NFC", 4 );
					i=i+4;
				}
				if((cm & WPS_CONFIG_METHOD_PBC) == WPS_CONFIG_METHOD_PBC){
					if((cm & WPS_CONFIG_METHOD_VPBC) == WPS_CONFIG_METHOD_VPBC){
						strncpy( cms+i, " VPBC", 5 );
						i=i+5;
					}else if((cm & WPS_CONFIG_METHOD_PPBC) == WPS_CONFIG_METHOD_PPBC){
						strncpy( cms+i, " PPBC", 5 );
						i=i+5;
					}else{
						strncpy( cms+i, " PBC", 4 );
						i=i+4;
					}
				}
				if((cm & WPS_CONFIG_METHOD_KEYPAD) == WPS_CONFIG_METHOD_KEYPAD){
					strncpy( cms+i, " PAD", 4 );
					i=i+4;
				}

				break;
			}	
		}
		fclose( pf );
	}
	
}

//After scan, it will get other devices' device name.
void p2p_device_name(struct p2p *p, char *scan_addr, char *dns)
{
	FILE *pf = NULL;
	int i;
	char parse[100] = {0x00};
	memset( dns, 0x00, 32 );

	memset( p->cmd, 0x00, CMD_SZ );
	sprintf( p->cmd, "iwpriv %s p2p_get2 devN=%s > %s", p->ifname, scan_addr,CONFIG_CM_PATH);	
	system( p->cmd );	
	system("sync");	
		
	pf = fopen( CONFIG_CM_PATH, "r" );
	if ( pf )
	{
		while( !feof( pf ) ){
			memset( parse, 0x00, CMD_SZ );
			fgets( parse, CMD_SZ, pf );
			if( strncmp( parse, "N=", 2) == 0 )
			{
				strncpy( dns, parse+2, 32);
				for( i=0; i<32; i++)
				{
					if(*(dns+i) == '\n'){
						*(dns+i) = '\0' ;
						break;
					}
				}
				if (i == 32){
					dns[31] = '\0';
				}

				break;
			}	
		}
		fclose( pf );
	}
}

//Successively query local device status with interval "POLLING_INTERVAL"
//when status == P2P_STATE_RX_PROVISION_DIS_REQ, 
//it require user to insert corresponding WPS config method
void *polling_status(void *arg)
{
	struct p2p *p=(struct p2p*)arg;
	
	while(p->res == 0){

		p2p_status(p, 0);
		if( p->status == P2P_STATE_RX_PROVISION_DIS_REQ )
		{
			p->thread_trigger = THREAD_DEVICE ;
			
			char peer_devaddr[18];
			char peer_req_cm[4];
			
			memset( peer_devaddr, 0x00, 18);
			memset( peer_req_cm, 0x00, 4);
			
			p2p_peer_devaddr(p, peer_devaddr);
			p2p_peer_req_cm(p, peer_req_cm);
			p2p_peer_info(p, p->peer_devaddr, peer_req_cm);

			ui_screen(p);

#if DEBUG

			if( (strncmp( peer_req_cm, "dis", 3) == 0) || (strncmp( peer_req_cm, "lab", 3) == 0) )
			{
				printf("Here is your PIN, insert c to continue: %d\n", p->pin);
			}
			else if( (strncmp( peer_req_cm, "pbc", 3) == 0) )
			{
				printf("Please push b to accept:\n");
			}
			else if( (strncmp( peer_req_cm, "pad", 3) == 0) )
			{
				printf("Please insert peer PIN code:\n");
			}
#endif

			break;
  	}

		//usleep( POLLING_INTERVAL );
		usleep(100*1000);
	}

	return NULL;
}

//If p2p device becomes GO, we still polling driver status
//to check whether some other p2p devices connected
void *polling_client(void *arg)
{
	struct p2p *p=(struct p2p*)arg;
	
	while( 1 ){

		p2p_status(p, 0);
		if( p->status == P2P_STATE_RX_PROVISION_DIS_REQ )
		{
			p->thread_trigger = THREAD_GO ;
			
			char peer_devaddr[18];
			char peer_req_cm[4];
			
			memset( peer_devaddr, 0x00, 18);
			memset( peer_req_cm, 0x00, 4);
			
			p2p_peer_devaddr(p, peer_devaddr);
			p2p_peer_req_cm(p, peer_req_cm);
			p2p_peer_info(p, p->peer_devaddr, peer_req_cm);

			ui_screen(p);

			//strncpy(p->peer_devaddr, peer_devaddr, 17);
			if( (strncmp( peer_req_cm, "dis", 3) == 0) || (strncmp( peer_req_cm, "lab", 3) == 0) )
			{
				printf("Here is your PIN, insert c to continue: %d\n", p->pin);
			}
			else if( (strncmp( peer_req_cm, "pbc", 3) == 0) )
			{
				printf("Please push b to accept; stauts:%d:\n", p->status);
			}
			else if( (strncmp( peer_req_cm, "pad", 3) == 0) )
			{
				printf("Please insert peer PIN code:\n");
			}

			break;
  	}

		usleep( POLLING_INTERVAL );
	}

	return NULL;
}

void reset_p2p_link(struct p2p *p)
{
		p->wpa_open = 0;
		system("killall wpa_supplicant");
		p->ap_open = 0;
		system("killall hostapd");
		usleep(100*1000);
}

void link_dev0(struct p2p *p)
{
	p2p_devaddr(p);

	char msg[CMD_SZ];
	memset( msg, 0x00, CMD_SZ );
	char dis_msg[CMD_SZ];
	memset( dis_msg, 0x00, CMD_SZ );
	char label_msg[CMD_SZ];
	memset( label_msg, 0x00, CMD_SZ );


	if(strncmp(p->peer_devaddr, "00:00:00:00:00:00", 17) == 0)
	{
		strcpy( msg, "Please insert peer P2P device at first" );			
		p2p_prov_disc_no_addr(p, msg);
		msg_failed = 1;
		p->enable = -1;
	}
	else
	{
#if DEBUG
		strcpy( msg, "Please insert WPS configuration method ;[0]display, [1]keypad, [2]pbc, [3]label:\n" );
		strcpy( dis_msg, "Please insert PIN code displays on peer device screen:" );
		strcpy( label_msg, "Please insert PIN code displays on peer label:" );
#endif
		p2p_prov_disc(p, msg, dis_msg, label_msg);
	}
}

void link_dev1(struct p2p *p)
{
	int error = 0;
	int count = 0;
	p->thread_trigger = THREAD_NONE;
	p->wps_info=2;
	p2p_wpsinfo(p);

#if P2P_SCAN_THREAD
	if (p->res_scan == 0){
		p->res_scan = 1;
		pthread_cancel(p->pthread_scan);
	}
#endif


#if 1
	while(count < 10){
		get_p2p_cur_status(p);
		if (p->status == P2P_STATE_RX_PROVISION_DIS_REQ){
			error ++;
			printf("\n ------------------ p2p status is wrong !-------------\n");
		}
		count ++;
		usleep(400*1000);
	}
	if (error >= 6){
		p2p_draw_link_out();
		msg_failed = 1;
		p->enable = -1;
		return ;
	}
#endif

	if(p->status != P2P_STATE_GONEGO_OK)
	{
		p2p_nego_proc(p);
	}					
	else
	{
		p2p_role(p,0);
		p2p_ifaddr(p);

		if( p->role == P2P_ROLE_CLIENT )
		{
			p2p_client_mode_proc(p);
		}
		else if( p->role == P2P_ROLE_GO )
		{
			p2p_go_mode_proc(p);
		}
	}

}



