
#include "p2p.h"
#include "res_utf8_1.h"
#include <unistd.h>

extern SDL_Surface* screen;

struct p2p *pp=NULL;
int cur_list_index = 0;
TTF_Font* main_font;
SDL_Color text_color = {255,255,255};
int p2p_mode = 0;
static unsigned int loop_count = 0;
void open_sdl_key();
extern void Apply_surface(int x,int y,SDL_Surface* source,SDL_Surface* destination,SDL_Rect* clip);

SDL_TimerID t_id;
SDL_sem* fd_lock = NULL;

extern char dns[8][SSID_SZ];

SDL_Surface* bg_list = NULL,* bg_link = NULL,* link_title = NULL,* dev_num = NULL,* dev_name = NULL,* link_fail = NULL,* link_start = NULL,* link_scaning = NULL,* scan_fail = NULL,* link_ok = NULL,* link_scaning1 = NULL,* link_start1 = NULL, * link_out = NULL, * link_title1 = NULL;

static int p2p_link_ok = 0;
static int first_loop = 0;

void p2p_draw_scan_ui();
void p2p_draw_linking();
void stop_timer();


char *naming_wpsinfo(int wps_info)
{
	switch(wps_info)
	{
		case P2P_NO_WPSINFO: return ("P2P_NO_WPSINFO");
		case P2P_GOT_WPSINFO_PEER_DISPLAY_PIN: return ("P2P_GOT_WPSINFO_PEER_DISPLAY_PIN");
		case P2P_GOT_WPSINFO_SELF_DISPLAY_PIN: return ("P2P_GOT_WPSINFO_SELF_DISPLAY_PIN");
		case P2P_GOT_WPSINFO_PBC: return ("P2P_GOT_WPSINFO_PBC");
		default: return ("UI unknown failed");
	}
}

char *naming_role(int role)
{
	switch(role)
	{
		case P2P_ROLE_DISABLE: return ("P2P_ROLE_DISABLE");
		case P2P_ROLE_DEVICE: return ("P2P_ROLE_DEVICE");
		case P2P_ROLE_CLIENT: return ("P2P_ROLE_CLIENT");
		case P2P_ROLE_GO: return ("P2P_ROLE_GO");
		default: return ("UI unknown failed");
	}
}

char *naming_status(int status)
{
	switch(status)
	{
		case P2P_STATE_NONE: return ("P2P_STATE_NONE");
		case P2P_STATE_IDLE: return ("P2P_STATE_IDLE");
		case P2P_STATE_LISTEN: return ("P2P_STATE_LISTEN");
		case P2P_STATE_SCAN: return ("P2P_STATE_SCAN");
		case P2P_STATE_FIND_PHASE_LISTEN: return ("P2P_STATE_FIND_PHASE_LISTEN");
		case P2P_STATE_FIND_PHASE_SEARCH: return ("P2P_STATE_FIND_PHASE_SEARCH");
		case P2P_STATE_TX_PROVISION_DIS_REQ: return ("P2P_STATE_TX_PROVISION_DIS_REQ");
		case P2P_STATE_RX_PROVISION_DIS_RSP: return ("P2P_STATE_RX_PROVISION_DIS_RSP");
		case P2P_STATE_RX_PROVISION_DIS_REQ: return ("P2P_STATE_RX_PROVISION_DIS_REQ");
		case P2P_STATE_GONEGO_ING: return ("P2P_STATE_GONEGO_ING");
		case P2P_STATE_GONEGO_OK: return ("P2P_STATE_GONEGO_OK");
		case P2P_STATE_GONEGO_FAIL: return ("P2P_STATE_GONEGO_FAIL");
		case P2P_STATE_RECV_INVITE_REQ: return ("P2P_STATE_RECV_INVITE_REQ");
		case P2P_STATE_PROVISIONING_ING: return ("P2P_STATE_PROVISIONING_ING");
		case P2P_STATE_PROVISIONING_DONE: return ("P2P_STATE_PROVISIONING_DONE");
		default: return ("UI unknown failed");
	}
}

char* naming_enable(int enable)
{
	switch(enable)
	{
		case  P2P_ROLE_DISABLE: return ("[Disabled]");
		case  P2P_ROLE_DEVICE: return ("[Enable/Device]");
		case  P2P_ROLE_CLIENT: return ("[Enable/Client]");
		case  P2P_ROLE_GO: return ("[Enable/GO]");
		default: return ("UI unknown failed");
	}
}

void  ui_screen(struct p2p *p)
{

#if DEBUG
	if(p->p2p_get==0)
	{
	}	
	else if(p->p2p_get==1)
	{
		//printf("\n**************************%-98s*\n", p->print_line);
		log_debug("\n**************************%-98s*\n", p->print_line);
	}
#endif

}

void init_p2p(struct p2p *p)
{

	memset(p->dev_name,0,32);
	strcpy( p->ifname, NET_NAME);
	p->enable = P2P_ROLE_DISABLE;
	p->res = 1;
	p->res_go = 1;
	p->res_scan = 1;
	p->status = P2P_STATE_NONE;
	if (p2p_mode == 0)
		p->intent = 15;
	else
		p->intent = 1;
	p->wps_info = 0;
	p->wpsing = 0;
	p->pin = 12345670;
	p->role = P2P_ROLE_DISABLE;
	p->listen_ch = 11;
	strcpy( p->peer_devaddr, "00:00:00:00:00:00" );
	p->p2p_get = 0;
	memset( p->print_line, 0x00, CMD_SZ);
	p->have_p2p_dev = 0;
	p->count_line = 0;
	strcpy( p->peer_ifaddr, "00:00:00:00:00:00" );
	memset( p->cmd, 0x00, CMD_SZ);
	p->wpa_open=0;
	p->ap_open=0;
	strcpy(p->ok_msg, "WiFi Direct handshake done" );
	strcpy(p->redo_msg, "Re-do GO handshake" );
	strcpy(p->fail_msg, "GO handshake unsuccessful" );	
	strcpy(p->nego_msg, "Start P2P negotiation" );
	strcpy(p->wpa_conf, WPA_CONF_DIR);
//	strcpy(p->wpa_conf, "/usr/etc/p2p/wpa_supplicant.conf" );
	strcpy(p->wpa_path, "/bin" );
	strcpy(p->ap_conf, TRL_HOSTAPD_DIR);
	//strcpy(p->ap_conf, "/usr/etc/p2p/rtl_hostapd.conf" );
	strcpy(p->ap_path, "/bin" );

	/* clear wpa conf */

#if 0
	sprintf(p->cmd,"rm -f %s;cp %s %s",p->wpa_conf,WPA_CONF_DIR,p->wpa_conf);
	system(p->cmd);
	system("sync");
	memset( p->cmd, 0x00, CMD_SZ);
#endif
	
}

void p2p_load_drv()
{
	char scan[CMD_SZ];
 	memset(scan,0,CMD_SZ);
	sprintf(scan,"insmod %s",P2P_DRIVER_DIR);
	system(scan);
	usleep(5000*1000);
}

void p2p_init_driver()
{
	/* turn on wifi power */
	system("echo 1 > /proc/jz/wifi_pw");
	usleep(500*1000);
	p2p_load_drv();


	char scan[CMD_SZ];
 	memset(scan,0,CMD_SZ);
	sprintf(scan, "ifconfig %s up",NET_NAME);
	system(scan);
	usleep(1000*1000);
}

void p2p_deinit_driver()
{
	char scan[CMD_SZ];
 	memset(scan,0,CMD_SZ);
	sprintf(scan,"ifconfig %s down",NET_NAME);
	system(scan);
	usleep(500*1000);
 	memset(scan,0,CMD_SZ);
	sprintf(scan,"rmmod %s",P2P_DRIVER_DIR);
	system(scan);
	usleep(500*1000);
	

	/* turn on wifi power */
	system("echo 0 > /proc/jz/wifi_pw");
	usleep(100*1000);

}
void deinit_font()
{
	TTF_CloseFont(main_font);
}

#if 0
int init_display()
{
	int i;
#if P2P_CARTOON
	if (SDL_Init(SDL_INIT_TIMER | SDL_INIT_VIDEO) < 0){
		printf("unable to init SDL: %s",SDL_GetError());
		return -1;
	}
#else
	if (SDL_Init(SDL_INIT_VIDEO) < 0){
		printf("unable to init SDL: %s",SDL_GetError());
		return -1;
	}

#endif
	SDL_ShowCursor(SDL_DISABLE);
	screen = SDL_SetVideoMode(SCREEN_W,SCREEN_H,SCREEN_DEPTH,SDL_SWSURFACE);
	if (screen == NULL){
		printf("unable to set %dx%d screen\n",SCREEN_W,SCREEN_H);
		return -1;
	}

	if ((i = TTF_Init()) != 0)
		printf("ttf init failed!\n");
	return 0;
}
#endif

int p2p_init_system()
{
	pp = (struct p2p* )malloc(sizeof(struct p2p));
	if( pp != NULL)
	{
		memset(pp, 0x00, sizeof(struct p2p));
		init_p2p(pp);
	}else{
		printf("struct p2p malloc failed!\n");
		return -1;
	}

	return 0;
}

void p2p_deinit_menu()
{
	free_surface(bg_list);
	free_surface(bg_link);
	free_surface(link_title);
	free_surface(link_title1);
	free_surface(dev_name);
	free_surface(dev_num);
	free_surface(link_fail);
	free_surface(scan_fail);
	free_surface(link_start);
	free_surface(link_start1);
	free_surface(link_scaning);
	free_surface(link_scaning1);
	free_surface(link_ok);
	free_surface(link_out);
}

void p2p_clear_config_file(struct p2p* p)
{
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf(p->cmd,"rm -f %s",CONFIG_SUPP_PATH);
	system(p->cmd);
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf(p->cmd,"rm -f %s",CONFIG_TEMP_PATH);
	system(p->cmd);
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf(p->cmd,"rm -f %s",CONFIG_SCAN_PATH);
	system(p->cmd);
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf(p->cmd,"rm -f %s",CONFIG_PEER_PATH);
	system(p->cmd);
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf(p->cmd,"rm -f %s",CONFIG_STATUS_PATH);
	system(p->cmd);
	memset( p->cmd, 0x00, CMD_SZ );
	sprintf(p->cmd,"rm -f %s",CONFIG_CM_PATH);
	system(p->cmd);
	system("sync");
	usleep(100*1000);
}

void p2p_deinit()
{
	/* Disable P2P functionalities when exits*/
#if P2P_SCAN_THREAD
	if( pp->res_scan == 0 ){
		pp->res_scan = 1;
		usleep(50*1000);
		pthread_cancel(pp->pthread_scan);
	}
#endif
	if( pp->res == 0 ){
		pp->res = 1;
		usleep(50*1000);
		pthread_cancel(pp->pthread);
	}
	usleep(500*1000);

	if (pp->enable == -1){
		usleep(1000*1000);
		p2p_enable(pp);
		usleep(1000*1000);
		p2p_deinit_driver();
	}


	p2p_deinit_menu();
	deinit_font();

	p2p_clear_config_file(pp);
	
	if(pp != NULL){
		free(pp);
		pp = NULL;
	}

	open_sdl_key();

	//TTF_Quit();
	//SDL_Quit();
}



#if 0
int init()
{
	int ret = init_display() || init_system();
	return ret;

}
#endif

void p2p_init_able(void)
{
	pp->enable=P2P_ROLE_DISABLE;
	p2p_enable(pp);
	p2p_get_hostapd_conf(pp);
	pp->enable = P2P_ROLE_DEVICE;
	p2p_enable(pp);
	usleep(50000);
}


void get_ui_font()
{
	main_font = load_font(FONT_DIR,MAIN_TEXT_FONT_SIZE);
}


#if 0
int get_sys_language(void)
{
	return 0;
  FILE *fd;
  int ret = 0;
  fd = fopen(LANGUAGE_PATH,"rb");
  char str_temp[128] ={0};
  int i = 0;
  if(fd)
  {
    fread(str_temp,sizeof(str_temp),sizeof(char),fd);
    for(i = 0; i < sizeof(str_temp);i++)
    {
      if(str_temp[i] == '\n')
      {
        str_temp[i] = 0x00;
        break;
      }
    }
    for(i = 0; i < LANGUAGE_MAX_NUM; i++)
    {
      if(!strcmp(&str_temp[strlen(LANGUAGE_SET_STR)],language_str[i]))
      {
        fclose(fd); 
        return i; 
      }
    }
    fclose(fd); 
  }
  return ret;
}
#endif




extern int get_sys_language(void);
extern SDL_Surface* background;
void p2p_init_menu()
{
	int lang_value = get_sys_language();
	get_ui_font();
	bg_list = load_image(BG_LIST_DIR);
	bg_link = load_image(BG_LINK_DIR);
	link_title = draw_text(res_title[lang_value],main_font,&text_color);
	link_title1 = draw_text(res_title1[lang_value],main_font,&text_color);
	dev_name = draw_text(res_dev_name[lang_value],main_font,&text_color);
	dev_num = draw_text(res_dev_num[lang_value],main_font,&text_color);
	link_fail = draw_text(res_fail[lang_value],main_font,&text_color);
	scan_fail = draw_text(res_scan_fail[lang_value],main_font,&text_color);
	link_start = draw_text(res_start0[lang_value],main_font,&text_color);
	link_scaning = draw_text(res_scan0[lang_value],main_font,&text_color);
	link_ok = draw_text(res_ok[lang_value],main_font,&text_color);
	link_scaning1 = draw_text(res_scan1[lang_value],main_font,&text_color);
	link_start1 = draw_text(res_start1[lang_value],main_font,&text_color);
	link_out = draw_text(res_out[lang_value],main_font,&text_color);
}


void p2p_draw_bg()
{
	sdl_draw_pic(0,0,background,screen);
	Apply_surface((SCREEN_W-bg_link->w)/2,(SCREEN_H-bg_link->h)/2,bg_link,screen,NULL);
	if (p2p_mode)
		Apply_surface((SCREEN_W-link_title->w)/2,50,link_title1,screen,NULL);
	else
		Apply_surface((SCREEN_W-link_title1->w)/2,50,link_title,screen,NULL);
	Apply_surface(170*SCREEN_W/320,80,dev_name,screen,NULL);
	Apply_surface(70*SCREEN_W/320,80,dev_num,screen,NULL);

}

void p2p_draw_dev_list(int ret)
{
	if (first_loop == 0){
		first_loop = 1;
		stop_timer();
	}

	int i=0;
	p2p_draw_bg();
	char str[10] = {0};
	char str1[SSID_SZ] = {0};
	char *ts = NULL;
	for (i=0;i<ret;i++){
		memset(str,0,10);
		sprintf(str,"%d",i+1);
		sdl_draw_text(70*SCREEN_W/320,110+10*i,main_font,&text_color,str,screen);
		strncpy(str1,dns[i],SSID_SZ);
		ts = strrchr(str1,'-');
		if (ts != NULL)
			*ts = '\0';
		sdl_draw_text(150*SCREEN_W/320,110+10*i,main_font,&text_color,str1,screen);
	}
	Apply_surface((SCREEN_W-bg_list->w)/2,110+10*cur_list_index,bg_list,screen,NULL);
	SDL_Flip(screen);
}

int scan_timer_callback(int delay,void * param)
{
	SDL_SemWait(fd_lock);
	p2p_draw_scan_ui();
	SDL_SemPost(fd_lock);
	return delay;
}

int link_timer_callback(int delay,void * param)
{
	SDL_SemWait(fd_lock);
	p2p_draw_linking();
	SDL_SemPost(fd_lock);
	return delay;
}


void scan_start_timer()
{
#if P2P_CARTOON
	t_id = SDL_AddTimer(500,scan_timer_callback,NULL);
	fd_lock = SDL_CreateSemaphore(1);
#else
	p2p_draw_scan_ui();
#endif

}

void link_start_timer()
{
#if P2P_CARTOON
	t_id = SDL_AddTimer(500,link_timer_callback,NULL);
	fd_lock = SDL_CreateSemaphore(1);
#else
	p2p_draw_linking();
#endif
}

void stop_timer()
{
#if P2P_CARTOON
	SDL_DestroySemaphore(fd_lock);
	SDL_RemoveTimer(t_id);
#endif
}


void p2p_draw_scan_ui()
{
	loop_count ++;
	p2p_draw_bg();
	if (loop_count%2 == 0)
		Apply_surface((SCREEN_W-link_scaning->w)/2,(SCREEN_H-link_scaning1->h)/2+50,link_scaning1,screen,NULL);
	else
		Apply_surface((SCREEN_W-link_scaning->w)/2,(SCREEN_H-link_scaning->h)/2+50,link_scaning,screen,NULL);
	SDL_Flip(screen);
}

void p2p_draw_scan_fail()
{
	p2p_draw_bg();
	Apply_surface((SCREEN_W-scan_fail->w)/2,(SCREEN_H-scan_fail->h)/2+50,scan_fail,screen,NULL);
	SDL_Flip(screen);
}

void p2p_draw_link_fail()
{
	p2p_draw_bg();
	Apply_surface((SCREEN_W-link_fail->w)/2,(SCREEN_H-link_fail->h)/2+50,link_fail,screen,NULL);
	SDL_Flip(screen);
}

void p2p_draw_link_ok()
{
	p2p_draw_bg();
	Apply_surface((SCREEN_W-link_ok->w)/2,(SCREEN_H-link_ok->h)/2+50,link_ok,screen,NULL);
	SDL_Flip(screen);
}
void p2p_draw_linking()
{
	loop_count ++;
	p2p_draw_bg();
	if (loop_count%2 == 0)
		Apply_surface((SCREEN_W-link_start->w)/2,(SCREEN_H-link_start1->h)/2+50,link_start1,screen,NULL);
	else
		Apply_surface((SCREEN_W-link_start->w)/2,(SCREEN_H-link_start->h)/2+50,link_start,screen,NULL);
	SDL_Flip(screen);
}

void p2p_draw_link_out()
{
	p2p_draw_bg();
	Apply_surface((SCREEN_W-link_out->w)/2,(SCREEN_H-link_out->h)/2+50,link_out,screen,NULL);
	SDL_Flip(screen);
}

void open_sdl_key()
{
	system("echo 1 > /proc/jz/alt");
	usleep(50*1000);
}

void close_sdl_key()
{
	system("echo 0 > /proc/jz/alt");
	usleep(50*1000);
}


void p2p_main_loop()
{
	int link_ok_flag = 0;
	int program_done = 1,ret = 0;
//	int count = 0;
	SDLKey key;
	SDL_Event event;
	SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY,SDL_DEFAULT_REPEAT_INTERVAL);//set delay to 0 disables  key repeat
	while(program_done){
		if (SDL_PollEvent(&event)){
				switch (event.type){
						case SDL_QUIT: 
								program_done = 0;
								pp->enable = -1;
								break;
						case SDL_KEYDOWN:
								key = event.key.keysym.sym;
								switch(key){
										case DINGOO_UP:
											if (ret > 0){
												cur_list_index --;
												if (cur_list_index < 0)
													cur_list_index = ret - 1;
											}
											break;
										case DINGOO_DOWN:
											if (ret > 0){
												cur_list_index ++;
												if (cur_list_index > ret - 1)
													cur_list_index = 0;
											}
											break;
										case DINGOO_A:
											if (link_ok_flag == 1){
												p2p_link_ok = 1;
												program_done = 0;
												break;
											}

											if (ret > 0 && link_ok_flag == 0){
												close_sdl_key();
												set_msg_link(0);
												link_start_timer();

											//	p2p_draw_linking();
												printf("\n medive %d\n",pp->thread_trigger);
												if (pp->thread_trigger == THREAD_NONE){
													link_dev0(pp);
												}else if(pp->thread_trigger == THREAD_DEVICE){
													link_dev1(pp);
												}
												if (get_msg_link() == 1){
													program_done = 0;
													pp->enable = -1;
												}
												if (get_msg_link() == 0 && pp->enable != -1){
													link_ok_flag = 1;
													program_done = 0;
													p2p_link_ok = 1;
													//pp->enable = -1;
												}
												stop_timer();
											}
											
											break;
										case DINGOO_B:
											close_sdl_key();
											p2p_draw_link_out();
											stop_timer();
											program_done = 0;
											pp->enable = -1;
											break;
										default : break;
								}
								break;
						case SDL_KEYUP:
								break;

				}
		}
		if (ret <= 0){
#if P2P_SCAN_THREAD
			ret = get_dev_num();
#else
			ret = p2p_scan_dev(pp);
#endif
			if (get_mode_error_flag()){
				printf("\n ################################### \n\n\n");
				stop_timer();
				p2p_draw_scan_fail();
				pp->enable = -1;
				return;
			}
			if (ret > 0){
				p2p_draw_dev_list(ret);
			}

		}
		if (ret > 0){
			if (link_ok_flag == 1){
				p2p_draw_link_ok();
			}else if (get_msg_link() == 1){
				//p2p_draw_link_fail();
			}else
				//p2p_draw_dev_list(ret);
				;

		}else{
		//	p2p_draw_scan_ui();
		}
#if P2P_SCAN_THREAD
#else
		if (ret <= 0)
			count ++;
		if (count >= SCAN_MAX_NUM){
			set_dev_num(1);
			stop_timer();
			p2p_draw_scan_fail();
			usleep(1000*1000);
			program_done = 0;
			pp->enable = -1;
		}
#endif
	}
}


void init_global()
{
	p2p_mode = 0;
	cur_list_index = 0;
	loop_count = 0;
	first_loop = 0;
	p2p_link_ok = 0;
	set_mode_error_flag(0);
	set_msg_link(0);
	memset(dns,0,32*8);
#if P2P_SCAN_THREAD
	set_dev_num(0);
#endif
}

int p2p_main(int mode)
{

	close_sdl_key();

	int ret=0;

		init_global();


	p2p_mode = mode;
	if (p2p_mode !=0 && p2p_mode != 1){
		printf("p2p mode error!\n");
		return -1;
	}

	/* init screen */
#if 0
	if (init() != 0){
		printf("system init failed !\n");
		return -1;
	}
#else
	if (p2p_init_system() < 0){
		return -1;
	}
#endif

	/* init menu */
	p2p_init_menu();


	/* Draw background */
	//p2p_draw_scan_ui();
	scan_start_timer();




	//start_flush_screen();

	/* init p2p driver */
	p2p_init_driver();
		
	/* Disable P2P functionalities at first*/
	p2p_init_able();

	open_sdl_key();

	/* main loop */
	p2p_main_loop();


	//stop_flush_screen();
	p2p_deinit();

	if (p2p_link_ok != 1){
		return -1;
	}
	
	return ret;

}


