#include "sound.h"
#include "conf.h"
#include "common.h"
#include "resource.h"

extern cfg_t *cfg;
extern cfg_t *cfg_main;
Mix_Chunk* sound_effects[6];
static int sound_value = 0;

int get_sound_value()
{
	return sound_value;
}
#if 0
void load_sound(char* file, MenuSound snd) 
{
    if (cfg_getstr(cfg, file) != NULL) 
    {
        sound_effects[snd] = load_theme_sound(cfg_getstr(cfg, file));
    }
}

void sound_init()
{ 
#if SOUND_ENABLED
		int i;
    if(Mix_OpenAudio(MIX_DEFAULT_FREQUENCY,MIX_DEFAULT_FORMAT,2,1024)<0) {
        log_error( "Can't initialize Sounds." );
    }
    log_debug("Sound Init Ok\n");
    
    load_sound("MenuSE",     MENU_MOVE);
    load_sound("MenuItemSE", MENUITEM_MOVE);
    load_sound("DecideSE",   DECIDE);
    load_sound("CancelSE",   CANCEL);
    load_sound("OutSE",      OUT);
    load_sound("TestSE",     GLOBAL_KEY);
#endif
}
#else

char tmp_str_sound[512];
void load_sound(MenuSound snd) 
{
	char tmp_file[512];
	memset(tmp_file,0,512);
	switch (snd){
		case 0:
			strncpy(tmp_file,tmp_str_sound,512);
			strcat(tmp_file,"1.wav");
			break;
		case 1:
			strncpy(tmp_file,tmp_str_sound,512);
			strcat(tmp_file,"2.wav");
			break;
		case 2:
			strncpy(tmp_file,tmp_str_sound,512);
			strcat(tmp_file,"3.wav");
			break;
		case 3:
			strncpy(tmp_file,tmp_str_sound,512);
			strcat(tmp_file,"4.wav");
			break;
		case 4:
			strncpy(tmp_file,tmp_str_sound,512);
			strcat(tmp_file,"5.wav");
			break;
		case 5:
			strncpy(tmp_file,tmp_str_sound,512);
			strcat(tmp_file,"6.wav");
			break;
	}
	if (tmp_file != NULL)
        sound_effects[snd] = load_theme_sound_new(tmp_file);
}

void set_sound_flag_value(char *str)
{
	if (strstr(str,"s1")){
		sound_value = 0;
	}else if (strstr(str,"s2")){
		sound_value = 1;
	}else if (strstr(str,"s3")){
		sound_value = 2;
	}else if (strstr(str,"s4")){
		sound_value = 3;
	}else if (strstr(str,"s5")){
		sound_value = 4;
	}else
		sound_value = 0;
}
void sound_init()
{ 
	memset(tmp_str_sound,0,512);
	strncpy(tmp_str_sound, cfg_getstr(cfg_main,"Sound"),512);
	set_sound_flag_value(tmp_str_sound);
	printf("sound dir is %s\n",tmp_str_sound);
#if SOUND_ENABLED
	int i;
	if(Mix_OpenAudio(MIX_DEFAULT_FREQUENCY,MIX_DEFAULT_FORMAT,2,1024)<0) {
		log_error( "Can't initialize Sounds." );
	}
	load_sound(MENU_MOVE);
	load_sound(MENUITEM_MOVE);
	load_sound(DECIDE);
	load_sound(CANCEL);
	load_sound(OUT);
	load_sound(GLOBAL_KEY);
#endif
}

#endif

extern int server_flag;
extern int client_flag;
void sound_out(MenuSound se)
{
#if P2P_CONNECT
	if(server_flag == 0 || client_flag == 0)
		return;
#endif

#if SOUND_ENABLED
    if (sound_effects[se] != NULL) 
    {
        Mix_PlayChannel( -1, sound_effects[se], 0 );
    }
#endif
}

void sound_deinit()
{
    int i = 0;
#if P2P_CONNECT
    log_debug("De-initializing");
	if(server_flag <0 && client_flag < 0)
	{
		Mix_HaltChannel(-1);
		Mix_CloseAudio();
		for(i=0;i<6;i++) free_sound(sound_effects[i]);
	}
	else
	{
		for(i=0;i<6;i++) free_sound(sound_effects[i]);
	}
	return;
#endif

#if SOUND_ENABLED
    log_debug("De-initializing");
    Mix_HaltChannel(-1);
    for(;i<6;i++) free_sound(sound_effects[i]);
    Mix_CloseAudio();
#endif
}
